$APPTYPE GUI: $TYPECHECK ON: $SYMBOLTABLE ON

defint i,fHnd,rHnd,fFlags,rFlags
defstr title$="HotBasic(tm) Dialogs Test 1.4"
RANDOMIZE TIMER
SHOWCONSOLE

Declare SUB ShowTitle (tstr as STRING)

SUB ShowTitle
Color 11: PRINT tstr: Color 7
END SUB

create f as form
  width=380: height=100
  center
  icon="hotbasic.ico"
  caption=title$
  resizeable=false
  maximizebox=false

  create b0 as button
    left=10: top=10: width=80
    caption="Open File"
    onclick=OpenFile
  end create
  create b1 as button
    left=10: top=40: width=80
    caption="Save File"
    onclick=SaveFile
  end create
  create b2 as button
    left=100: top=10: width=80
    caption="Choose Font"
    onclick=ChooseFont
  end create
  create b3 as button
    left=100: top=40: width=80
    caption="Choose Color"
    onclick=ChooseColor
  end create
  create b4 as button
    left=190: top=10: width=80
    caption="Find Text"
    onclick=FindTxt
  end create
  create b5 as button
    left=190: top=40: width=80
    caption="Replace Text"
    onclick=ReplTxt
  end create
  create b6 as button
    left=280: top=10: width=80
    caption="Page Setup"
    onclick=PageDlg
  end create
  create b7 as button
    left=280: top=40: width=80
    caption="Print Dialog"
    onclick=PrtDlg
  end create

  create Open as opendialog
    caption = "HotBasic OpenDialog"
    DefExt = "sys"
    InitialDir = "C:\"
  end create
  create Save as savedialog
    caption = "HotBasic SaveDialog"
    DefExt = "txt"
    InitialDir = "C:\"
  end create
  create MyFont as font
    name="MS Sans Serif"
  end create
  font=MyFont
  create cFont as fontdialog
    font=MyFont
    flags=cFont.flags OR &H40  'CF_INITTOLOGFONTSTRUCT
  end create
  create cColor as colordialog
  end create
  create cFind as finddialog
  end create
  create cRepl as replacedialog
  end create
  create dPage as pagedialog
    dlgname="Paging HotBabe"
  end create
  create dPrint as printdialog
  end create
end create
  
PRINT title$

'use timers to simulate modal Find/Replace Dialogs
dim ftimer as timer
with ftimer: .interval=300: .repeated = true: .ontimer = fnddlg: end with

dim rtimer as timer
with rtimer: .interval=300: .repeated = true: .ontimer = repdlg: end with

f.showmodal
END

OpenFile:
Open.Flags = &H205800
IF Open.Execute THEN GOSUB ShowOpen
RETURN

SaveFile:
Save.Flags = &H202806
IF Save.Execute THEN GOSUB ShowSave
RETURN

ShowOpen:
ShowTitle "OPEN DIALOG"
PRINT "Open.Caption    = "; Open.Caption
PRINT "Open.DefExt     = "; Open.DefExt
PRINT "Open.FileName   = "; Open.FileName
PRINT "Open.Filter     = "; Open.Filter
PRINT "Open.Flags (hex)= "; HEX$(Open.Flags)
PRINT "Open.InitialDir = "; Open.InitialDir
RETURN

ShowSave:
ShowTitle "SAVE DIALOG"
PRINT "Save.Caption    = "; Save.Caption
PRINT "Save.DefExt     = "; Save.DefExt
PRINT "Save.FileName   = "; Save.FileName
PRINT "Save.Filter     = "; Save.Filter
PRINT "Save.Flags (hex)= "; HEX$(Save.Flags)
PRINT "Save.InitialDir = "; Save.InitialDir
RETURN

ChooseFont:
IF cFont.Execute THEN
  ShowTitle "FONT DIALOG"
  PRINT "New Font       = "; MyFont.Name
  PRINT "Device Context = "; HEX$(cFont.DC)
  PRINT "Point Size     = "; cFont.PointSize
  PRINT "Flags          = "; HEX$(cFont.Flags)
  PRINT "rgb Color      = "; HEX$(cFont.Color)
  PRINT "Min Font Size  = "; cFont.MinFontSize
  PRINT "Max Font Size  = "; cFont.MaxFontSize
  PRINT "Font Type      = "; HEX$(cFont.FontType)
  PRINT "Alignment      = "; cFont.Alignment
END IF
RETURN

ChooseColor:
'define crazy custom color set
FOR i=0 to 15: cColor.CC(i)=RND(&HFFFFFF): Next i

cColor.Flags = 1
IF cColor.Execute THEN
  ShowTitle "COLOR DIALOG"
  PRINT "New Color = "; HEX$(cColor.Color)
  PRINT "Flags     = "; HEX$(cColor.Flags)
END IF
RETURN

FindTxt:
cFind.Flags = 1
fHnd = cFind.Execute  'save handle
IF fHnd THEN ftimer.enabled = true
RETURN

fnddlg:
'turn off timer if dialog closed
i=cFind.Flags
IF i AND &H40 THEN ftimer.enabled = false 'FR_DIALOGTERM
IF fFlags <> i THEN
  ShowTitle "FIND DIALOG"
  PRINT "Find Text    = "; cFind.Find
  PRINT "Flags        = "; HEX$(i)
  fFlags = 1: cFind.Flags = 1
'  cFind.ondialog = OnFind: fFlags = &H101: cFind.Flags = &H101
END IF
RETURN

OnFind:
PRINT HEX$(hDlg);space;HEX$(mDlg);space;HEX$(wDlg);space;HEX$(lDlg)
RETVAL zero
RETURN

ReplTxt:
cRepl.Flags = 1
rHnd = cRepl.Execute
IF rHnd THEN rtimer.enabled = true
RETURN

repdlg:
i=cRepl.Flags
IF i AND &H40 THEN rtimer.enabled = false 'FR_DIALOGTERM
IF rFlags <> i THEN
  ShowTitle "REPLACE DIALOG"
  PRINT "Find Text    = "; cRepl.Find
  PRINT "Replace Text = "; cRepl.Replace
  PRINT "Flags        = "; HEX$(i)
  rFlags = 1: cRepl.Flags = 1
END IF
RETURN

PageDlg:
dPage.Flags = 0
IF dPage.execute THEN
  ShowTitle "PAGE SETUP DIALOG"
  Print "DlgName         = "; dPage.dlgname
  Print "Flags           = "; HEX$(dPage.flags)
  Print "PaperWidth      = "; dPage.paperwidth
  Print "PaperHeight     = "; dPage.paperheight
  Print "MinMarginLeft   = "; dPage.MinMarginLeft
  Print "MinMarginTop    = "; dPage.MinMarginTop
  Print "MinMarginRight  = "; dPage.MinMarginRight
  Print "MinMarginBottom = "; dPage.MinMarginBottom
  Print "MarginLeft      = "; dPage.MarginLeft
  Print "MarginTop       = "; dPage.MarginTop
  Print "MarginRight     = "; dPage.MarginRight
  Print "MarginBottom    = "; dPage.MarginBottom
END IF
RETURN

PrtDlg:
with dPrint
.frompage = 1: .topage = 4
.minpage = 1: .maxpage = 10: .flags = 0
end with
IF dPrint.execute THEN
  ShowTitle "PRINT DIALOG"
  Print "DC       = "; HEX$(dPrint.DC)
  Print "Flags    = "; HEX$(dPrint.flags)
  Print "FromPage = "; dPrint.frompage
  Print "ToPage   = "; dPrint.topage
  Print "MinPage  = "; dPrint.minpage
  Print "MaxPage  = "; dPrint.maxpage
  Print "Copies   = "; dPrint.copies
END IF
RETURN
