'cpuid.inc Copyright 2008 James J. Keene

'Reference:  http://www.sandpile.org/ia32/cpuid.htm

OBJECT CPUID
  HighestParameter as LONG
  VenderID as STRING*12
  Stepping as LONG  'offset=16; Processor Info
  Model as LONG
  Family as LONG
  Type as LONG
  ExtModel as LONG
  ExtFamily as LONG
  BrandID as BYTE   'offset=40
  CLFlush as BYTE
  CPUCount as BYTE = 1
  APIC_ID as BYTE
  Feature3 as LONG  'ECX result
  Feature4 as LONG  'EDX result
  Config1 as LONG   '52
  Config2 as LONG
  Config3 as LONG
  Config4 as LONG
  SerialNumber as LONG  'not implemented
  'L1D Cache values:
  Cache1 as LONG   'EAX '72
  Cache2 as LONG   'EBX
  Cache3 as LONG   'ECX
  Cache4 as LONG   'EDX
  Monitor1 as LONG 'EAX '88
  Monitor2 as LONG 'EBX
  Monitor3 as LONG 'ECX
  Monitor4 as LONG 'EDX
  Power1 as LONG   'EAX '104
  Power2 as LONG   'EBX
  Power3 as LONG   'ECX
  Power4 as LONG   'EDX
  PEMo1 as LONG    'EAX '120
  PEMo2 as LONG    'EBX
  PEMo4 as LONG    'EDX
  SMT1 as LONG     'EAX '132
  SMT2 as LONG     'EBX
  SMT3 as LONG     'ECX
  SMT4 as LONG     'EDX
  ExtStateMain1 as LONG 'EAX '148
  ExtStateMain2 as LONG 'EBX
  ExtStateMain3 as LONG 'ECX
  ExtStateMain4 as LONG 'EDX
  HighestExtended as LONG  '164
  Extended1 as LONG   'EAX '168  '80000001
  Extended2 as LONG   'EBX
  Extended3 as LONG   'ECX
  Extended4 as LONG   'EDX
  Brand as STRING*48  '184
  CodeTBLentries as BYTE '80000005 L1 cache and L1 TBL config
  CodeTBLassoc as BYTE
  DataTBLentries as BYTE
  DataTBLassoc as BYTE
  CodeTBLentries4KB as BYTE
  CodeTBLassoc4KB as BYTE
  DataTBLentries4KB as BYTE
  DataTBLassoc4KB as BYTE
  DataL1LineSize as BYTE
  DataL1LinesPerTag as BYTE
  DataL1assoc as BYTE
  DataL1SizeKB as BYTE
  CodeL1LineSize as BYTE
  CodeL1LinesPerTag as BYTE
  CodeL1assoc as BYTE
  CodeL1SizeKB as BYTE
  L2_L3Cache1 as LONG  '80000006  
  L2_L3Cache2 as LONG  
  L2_L3Cache3 as LONG  
  L2_L3Cache4 as LONG  
  EPM as LONG          '80000007
  PhysAddrBits as BYTE '80000008 EAX
  VirtAddrBits as BYTE
  GuestPhysAddrBits as BYTE
  Reserved1 as BYTE
  CPUCountInfo as LONG 'ECX
  SVM1 as LONG   'EAX  '8000000A
  SVM2 as LONG   'EBX
  SVM4 as LONG   'EDX
  TBL1 as LONG   'EAX  '80000019
  TBL2 as LONG   'EBX
  PerformOptim as LONG '8000001A EAX
END CPUID

declare sub CPUID_Init
declare sub CPU_ID Lib "CPU_ID.obj"

sub CPUID_Init
asm mov ebx,hbObj
CPU_ID
end sub
