'DirTree.inc Copyright 2004 James J Keene
'Updated: June 26, 2006

'Usage: MyList = DirTree(path$, mask)
'Please see string function DIR$() for mask values

'Returns LIST object enumerating directory tree.
'mask = &H10 for subdirectories only, else &H37.

Declare FUNCTION DirTree (DT$ As String, maskbits As LONG) As STRING
Declare SUB GetPath(this_path As STRING)

$DEFINE Max_Tree_Items 16000

'global variables 
DEFSTR tree$
DIM unread(Max_Tree_Items) As BYTE
DEFINT tree_count

FUNCTION DirTree(DT$ As String, maskbits As LONG) As STRING
DEFINT i,j  'scratch variables
tree$.clear
'get "root" path
tree_count=-1: GetPath(DT$): j=zero
next_subdir:
FOR i=j to tree_count 
IF unread(i) THEN
  j=i: INC(j): GetPath(tree$.Item(i))
  unread(i)=zero: Goto next_subdir
END IF
NEXT i
result=tree$
END FUNCTION

SUB GetPath(this_path As STRING)
$IFDEF LINUX
defstr slash="/"
$define dirbit &H4000
$ELSE
defstr slash="\"
$define dirbit &H10
$ENDIF
DEFINT IsDir: DEFSTR r$
IF this_path[this_path.length]<>slash THEN this_path.write(slash)
$IFNDEF LINUX
r$ = Dir$(this_path+"*.*",maskbits) 'gets first item
$ELSE
r$ = Dir$(this_path,maskbits) 'gets first item
$ENDIF
Goto getpath_add
getpath_next:
r$ = Dir$  'get next item
getpath_add:
IF r$.Length THEN
  IF right$(r$,1)="." THEN Goto getpath_next
  INC(tree_count)
  IF tree_count>Max_Tree_Items THEN
    SHOWMESSAGE "Too Many Tree Items"
    APP.Terminate
  END IF 
  IF FILEREC.Attr AND dirbit THEN IsDir=one ELSE IsDir=zero
  tree$.AddItems this_path+r$: unread(tree_count)=IsDir
  Goto getpath_next
END IF
END SUB

$UNDEF Max_Tree_Items
