'FindFile.inc Copyright 2006 James J Keene
'Updated: Aug 16, 2006

'Usage: MyList = FindFile(FF$, mode)
'  where FF$ is the filename string
'  and mode = 0 (find all), = 1 (find one)
'Returns LIST object enumerating one or more FF$ pathnames.

'requires $include "DirTree.inc"

declare function FindFile (FF$ as string, mode as long) as string

function FindFile
defstr r$
defint i,j

begin runonce
  defstr d$,s$,t$
$IFDEF LINUX
  defstr slash="/"
  d$=slash
$ELSE
  declare sub GetLogicalDriveStringsA LIB "kernel32" _
    (d1 as long, d2 as long)
  d$=space$(1024)
  GetLogicalDriveStringsA 1024,@d$
  i=retfunc: d$=left$(d$,i)
  d$=replacesubstr$(d$,chr$(zero),crlf)
  defstr slash="\"
$ENDIF
end runonce

for i=zero to d$.itemcount-one 'search all drives
t$=d$.item(i)
if t$<"C:" then goto FF_drive  'skip floppies
t$=DirTree(t$,dirbit)  'get all directories on drive

for j=zero to t$.itemcount-one 'test all directories
s$=t$.item(j)+slash+FF$
if fileexists(s$) then
  r$.additems s$
  if mode then goto FF_done 
end if
next j

FF_drive:
next i

FF_done:
result=r$
end function

$undef dirbit  'defined in DirTree.inc
