'MD5.inc Copyright 2007 James J Keene
'Updated Oct 22, 2007
'based on RFC 1321

'Usage: MyString = MD5(objptr(stream))
'where stream is a STRING or FILE instance

declare function MD5 (MD5In as long) as string

function MD5
defint i,k,datEnd
defint64 i64
defbyte b0
defint A,B,C,D,AA,BB,CC,DD
defstr X: defint lpX=@X

use dat as FILE with MD5In
''Step 1 Part A
i=dat.size: i64 = i*8

''Step 3
A = &H67452301
B = &HEFCDAB89
C = &H98BADCFE
D = &H10325476

''Step 4.  Process the message in 16-word blocks
dat.position=zero: datEnd=2
while datEnd
X = dat.readstr(64)

IF X.len < 64 THEN  'oops, this is the end!
''Step 1 Part B: padding
  if datEnd=2 then b0 = &H80: X.write(b0): dec(datEnd)
  b0 = zero
  if X.len<=56 then k=55 else k=63
  for i=X.len to k: X.write(b0): next i
''Step 2
  if X.len=56 then X.write(i64): datEnd=zero
END IF

AA = A: BB = B: CC = C: DD = D
asm mov ebx,MD5lpX

'Round 1
''MD5R1 A,B,C,D, 0, 7, &HD76AA478: A=eax
'MD5F(b,c,d)
asm mov eax,MD5B: asm and eax,MD5C
asm mov edx,MD5B: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx]: asm add eax,0D76AA478h
asm rol eax,7: asm add eax,MD5B: A=eax
''MD5R1 D,A,B,C, 1,12, &HE8C7B756: D=eax
'MD5F(b,c,d)
asm mov eax,MD5A: asm and eax,MD5B
asm mov edx,MD5A: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+4]: asm add eax,0E8C7B756h
asm rol eax,12: asm add eax,MD5A: D=eax
''MD5R1 C,D,A,B, 2,17, &H242070DB: C=eax
'MD5F(b,c,d)
asm mov eax,MD5D: asm and eax,MD5A
asm mov edx,MD5D: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+8]: asm add eax,242070DBh
asm rol eax,17: asm add eax,MD5D: C=eax
''MD5R1 B,C,D,A, 3,22, &HC1BDCEEE: B=eax
'MD5F(b,c,d)
asm mov eax,MD5C: asm and eax,MD5D
asm mov edx,MD5C: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+12]: asm add eax,0C1BDCEEEh
asm rol eax,22: asm add eax,MD5C: B=eax
''MD5R1 A,B,C,D, 4, 7, &HF57C0FAF: A=eax
'MD5F(b,c,d)
asm mov eax,MD5B: asm and eax,MD5C
asm mov edx,MD5B: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+16]: asm add eax,0F57C0FAFh
asm rol eax,7: asm add eax,MD5B: A=eax
''MD5R1 D,A,B,C, 5,12, &H4787C62A: D=eax
'MD5F(b,c,d)
asm mov eax,MD5A: asm and eax,MD5B
asm mov edx,MD5A: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+20]: asm add eax,4787C62Ah
asm rol eax,12: asm add eax,MD5A: D=eax
''MD5R1 C,D,A,B, 6,17, &HA8304613: C=eax
'MD5F(b,c,d)
asm mov eax,MD5D: asm and eax,MD5A
asm mov edx,MD5D: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+24]: asm add eax,0A8304613h
asm rol eax,17: asm add eax,MD5D: C=eax
''MD5R1 B,C,D,A, 7,22, &HFD469501: B=eax
'MD5F(b,c,d)
asm mov eax,MD5C: asm and eax,MD5D
asm mov edx,MD5C: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+28]: asm add eax,0FD469501h
asm rol eax,22: asm add eax,MD5C: B=eax
''MD5R1 A,B,C,D, 8, 7, &H698098D8: A=eax
'MD5F(b,c,d)
asm mov eax,MD5B: asm and eax,MD5C
asm mov edx,MD5B: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+32]: asm add eax,698098D8h
asm rol eax,7: asm add eax,MD5B: A=eax
''MD5R1 D,A,B,C, 9,12, &H8B44F7AF: D=eax
'MD5F(b,c,d)
asm mov eax,MD5A: asm and eax,MD5B
asm mov edx,MD5A: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+36]: asm add eax,8B44F7AFh
asm rol eax,12: asm add eax,MD5A: D=eax
''MD5R1 C,D,A,B,10,17, &HFFFF5BB1: C=eax
'MD5F(b,c,d)
asm mov eax,MD5D: asm and eax,MD5A
asm mov edx,MD5D: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+40]: asm add eax,0FFFF5BB1h
asm rol eax,17: asm add eax,MD5D: C=eax
''MD5R1 B,C,D,A,11,22, &H895CD7BE: B=eax
'MD5F(b,c,d)
asm mov eax,MD5C: asm and eax,MD5D
asm mov edx,MD5C: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+44]: asm add eax,895CD7BEh
asm rol eax,22: asm add eax,MD5C: B=eax
''MD5R1 A,B,C,D,12, 7, &H6B901122: A=eax
'MD5F(b,c,d)
asm mov eax,MD5B: asm and eax,MD5C
asm mov edx,MD5B: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+48]: asm add eax,6B901122h
asm rol eax,7: asm add eax,MD5B: A=eax
''MD5R1 D,A,B,C,13,12, &HFD987193: D=eax
'MD5F(b,c,d)
asm mov eax,MD5A: asm and eax,MD5B
asm mov edx,MD5A: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+52]: asm add eax,0FD987193h
asm rol eax,12: asm add eax,MD5A: D=eax
''MD5R1 C,D,A,B,14,17, &HA679438E: C=eax
'MD5F(b,c,d)
asm mov eax,MD5D: asm and eax,MD5A
asm mov edx,MD5D: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+56]: asm add eax,0A679438Eh
asm rol eax,17: asm add eax,MD5D: C=eax
''MD5R1 B,C,D,A,15,22, &H49B40821: B=eax
'MD5F(b,c,d)
asm mov eax,MD5C: asm and eax,MD5D
asm mov edx,MD5C: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+60]: asm add eax,49B40821h
asm rol eax,22: asm add eax,MD5C: B=eax
      
'Round 2
''MD5R2 A,B,C,D, 1, 5, &HF61E2562: A=eax
'MD5G(b,c,d)
asm mov eax,MD5B: asm and eax,MD5D
asm mov edx,MD5D: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+4]: asm add eax,0F61E2562h
asm rol eax,5: asm add eax,MD5B: A=eax
''MD5R2 D,A,B,C, 6, 9, &HC040B340: D=eax
'MD5G(b,c,d)
asm mov eax,MD5A: asm and eax,MD5C
asm mov edx,MD5C: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+24]: asm add eax,0C040B340h
asm rol eax,9: asm add eax,MD5A: D=eax
''MD5R2 C,D,A,B,11,14, &H265E5A51: C=eax
'MD5G(b,c,d)
asm mov eax,MD5D: asm and eax,MD5B
asm mov edx,MD5B: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+44]: asm add eax,265E5A51h
asm rol eax,14: asm add eax,MD5D: C=eax
''MD5R2 B,C,D,A, 0,20, &HE9B6C7AA: B=eax
'MD5G(b,c,d)
asm mov eax,MD5C: asm and eax,MD5A
asm mov edx,MD5A: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx]: asm add eax,0E9B6C7AAh
asm rol eax,20: asm add eax,MD5C: B=eax
''MD5R2 A,B,C,D, 5, 5, &HD62F105D: A=eax
'MD5G(b,c,d)
asm mov eax,MD5B: asm and eax,MD5D
asm mov edx,MD5D: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+20]: asm add eax,0D62F105Dh
asm rol eax,5: asm add eax,MD5B: A=eax
''MD5R2 D,A,B,C,10, 9, &H02441453: D=eax
'MD5G(b,c,d)
asm mov eax,MD5A: asm and eax,MD5C
asm mov edx,MD5C: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+40]: asm add eax,02441453h
asm rol eax,9: asm add eax,MD5A: D=eax
''MD5R2 C,D,A,B,15,14, &HD8A1E681: C=eax
'MD5G(b,c,d)
asm mov eax,MD5D: asm and eax,MD5B
asm mov edx,MD5B: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+60]: asm add eax,0D8A1E681h
asm rol eax,14: asm add eax,MD5D: C=eax
''MD5R2 B,C,D,A, 4,20, &HE7D3FBC8: B=eax
'MD5G(b,c,d)
asm mov eax,MD5C: asm and eax,MD5A
asm mov edx,MD5A: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+16]: asm add eax,0E7D3FBC8h
asm rol eax,20: asm add eax,MD5C: B=eax
''MD5R2 A,B,C,D, 9, 5, &H21E1CDE6: A=eax
'MD5G(b,c,d)
asm mov eax,MD5B: asm and eax,MD5D
asm mov edx,MD5D: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+36]: asm add eax,21E1CDE6h
asm rol eax,5: asm add eax,MD5B: A=eax
''MD5R2 D,A,B,C,14, 9, &HC33707D6: D=eax
'MD5G(b,c,d)
asm mov eax,MD5A: asm and eax,MD5C
asm mov edx,MD5C: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+56]: asm add eax,0C33707D6h
asm rol eax,9: asm add eax,MD5A: D=eax
''MD5R2 C,D,A,B, 3,14, &HF4D50D87: C=eax
'MD5G(b,c,d)
asm mov eax,MD5D: asm and eax,MD5B
asm mov edx,MD5B: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+12]: asm add eax,0F4D50D87h
asm rol eax,14: asm add eax,MD5D: C=eax
''MD5R2 B,C,D,A, 8,20, &H455A14ED: B=eax
'MD5G(b,c,d)
asm mov eax,MD5C: asm and eax,MD5A
asm mov edx,MD5A: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+32]: asm add eax,455A14EDh
asm rol eax,20: asm add eax,MD5C: B=eax
''MD5R2 A,B,C,D,13, 5, &HA9E3E905: A=eax
'MD5G(b,c,d)
asm mov eax,MD5B: asm and eax,MD5D
asm mov edx,MD5D: asm not edx: asm and edx,MD5C
asm or eax,edx
asm add eax,MD5A: asm add eax,[ebx+52]: asm add eax,0A9E3E905h
asm rol eax,5: asm add eax,MD5B: A=eax
''MD5R2 D,A,B,C, 2, 9, &HFCEFA3F8: D=eax
'MD5G(b,c,d)
asm mov eax,MD5A: asm and eax,MD5C
asm mov edx,MD5C: asm not edx: asm and edx,MD5B
asm or eax,edx
asm add eax,MD5D: asm add eax,[ebx+8]: asm add eax,0FCEFA3F8h
asm rol eax,9: asm add eax,MD5A: D=eax
''MD5R2 C,D,A,B, 7,14, &H676F02D9: C=eax
'MD5G(b,c,d)
asm mov eax,MD5D: asm and eax,MD5B
asm mov edx,MD5B: asm not edx: asm and edx,MD5A
asm or eax,edx
asm add eax,MD5C: asm add eax,[ebx+28]: asm add eax,676F02D9h
asm rol eax,14: asm add eax,MD5D: C=eax
''MD5R2 B,C,D,A,12,20, &H8D2A4C8A: B=eax
'MD5G(b,c,d)
asm mov eax,MD5C: asm and eax,MD5A
asm mov edx,MD5A: asm not edx: asm and edx,MD5D
asm or eax,edx
asm add eax,MD5B: asm add eax,[ebx+48]: asm add eax,8D2A4C8Ah
asm rol eax,20: asm add eax,MD5C: B=eax
     
'Round 3
''MD5R3 A,B,C,D, 5, 4, &HFFFA3942: A=eax
'MD5H(b,c,d)
asm mov eax,MD5B: asm xor eax,MD5C: asm xor eax,MD5D
asm add eax,MD5A: asm add eax,[ebx+20]: asm add eax,0FFFA3942h
asm rol eax,4: asm add eax,MD5B: A=eax
''MD5R3 D,A,B,C, 8,11, &H8771F681: D=eax
'MD5H(b,c,d)
asm mov eax,MD5A: asm xor eax,MD5B: asm xor eax,MD5C
asm add eax,MD5D: asm add eax,[ebx+32]: asm add eax,8771F681h
asm rol eax,11: asm add eax,MD5A: D=eax
''MD5R3 C,D,A,B,11,16, &H6D9D6122: C=eax
'MD5H(b,c,d)
asm mov eax,MD5D: asm xor eax,MD5A: asm xor eax,MD5B
asm add eax,MD5C: asm add eax,[ebx+44]: asm add eax,6D9D6122h
asm rol eax,16: asm add eax,MD5D: C=eax
''MD5R3 B,C,D,A,14,23, &HFDE5380C: B=eax
'MD5H(b,c,d)
asm mov eax,MD5C: asm xor eax,MD5D: asm xor eax,MD5A
asm add eax,MD5B: asm add eax,[ebx+56]: asm add eax,0FDE5380Ch
asm rol eax,23: asm add eax,MD5C: B=eax
''MD5R3 A,B,C,D, 1, 4, &HA4BEEA44: A=eax
'MD5H(b,c,d)
asm mov eax,MD5B: asm xor eax,MD5C: asm xor eax,MD5D
asm add eax,MD5A: asm add eax,[ebx+4]: asm add eax,0A4BEEA44h
asm rol eax,4: asm add eax,MD5B: A=eax
''MD5R3 D,A,B,C, 4,11, &H4BDECFA9: D=eax
'MD5H(b,c,d)
asm mov eax,MD5A: asm xor eax,MD5B: asm xor eax,MD5C
asm add eax,MD5D: asm add eax,[ebx+16]: asm add eax,4BDECFA9h
asm rol eax,11: asm add eax,MD5A: D=eax
''MD5R3 C,D,A,B, 7,16, &HF6BB4B60: C=eax
'MD5H(b,c,d)
asm mov eax,MD5D: asm xor eax,MD5A: asm xor eax,MD5B
asm add eax,MD5C: asm add eax,[ebx+28]: asm add eax,0F6BB4B60h
asm rol eax,16: asm add eax,MD5D: C=eax
''MD5R3 B,C,D,A,10,23, &HBEBFBC70: B=eax
'MD5H(b,c,d)
asm mov eax,MD5C: asm xor eax,MD5D: asm xor eax,MD5A
asm add eax,MD5B: asm add eax,[ebx+40]: asm add eax,0BEBFBC70h
asm rol eax,23: asm add eax,MD5C: B=eax
''MD5R3 A,B,C,D,13, 4, &H289B7EC6: A=eax
'MD5H(b,c,d)
asm mov eax,MD5B: asm xor eax,MD5C: asm xor eax,MD5D
asm add eax,MD5A: asm add eax,[ebx+52]: asm add eax,289B7EC6h
asm rol eax,4: asm add eax,MD5B: A=eax
''MD5R3 D,A,B,C, 0,11, &HEAA127FA: D=eax
'MD5H(b,c,d)
asm mov eax,MD5A: asm xor eax,MD5B: asm xor eax,MD5C
asm add eax,MD5D: asm add eax,[ebx]: asm add eax,0EAA127FAh
asm rol eax,11: asm add eax,MD5A: D=eax
''MD5R3 C,D,A,B, 3,16, &HD4EF3085: C=eax
'MD5H(b,c,d)
asm mov eax,MD5D: asm xor eax,MD5A: asm xor eax,MD5B
asm add eax,MD5C: asm add eax,[ebx+12]: asm add eax,0D4EF3085h
asm rol eax,16: asm add eax,MD5D: C=eax
''MD5R3 B,C,D,A, 6,23, &H04881D05: B=eax
'MD5H(b,c,d)
asm mov eax,MD5C: asm xor eax,MD5D: asm xor eax,MD5A
asm add eax,MD5B: asm add eax,[ebx+24]: asm add eax,04881D05h
asm rol eax,23: asm add eax,MD5C: B=eax
''MD5R3 A,B,C,D, 9, 4, &HD9D4D039: A=eax
'MD5H(b,c,d)
asm mov eax,MD5B: asm xor eax,MD5C: asm xor eax,MD5D
asm add eax,MD5A: asm add eax,[ebx+36]: asm add eax,0D9D4D039h
asm rol eax,4: asm add eax,MD5B: A=eax
''MD5R3 D,A,B,C,12,11, &HE6DB99E5: D=eax
'MD5H(b,c,d)
asm mov eax,MD5A: asm xor eax,MD5B: asm xor eax,MD5C
asm add eax,MD5D: asm add eax,[ebx+48]: asm add eax,0E6DB99E5h
asm rol eax,11: asm add eax,MD5A: D=eax
''MD5R3 C,D,A,B,15,16, &H1FA27CF8: C=eax
'MD5H(b,c,d)
asm mov eax,MD5D: asm xor eax,MD5A: asm xor eax,MD5B
asm add eax,MD5C: asm add eax,[ebx+60]: asm add eax,1FA27CF8h
asm rol eax,16: asm add eax,MD5D: C=eax
''MD5R3 B,C,D,A, 2,23, &HC4AC5665: B=eax
'MD5H(b,c,d)
asm mov eax,MD5C: asm xor eax,MD5D: asm xor eax,MD5A
asm add eax,MD5B: asm add eax,[ebx+8]: asm add eax,0C4AC5665h
asm rol eax,23: asm add eax,MD5C: B=eax
    
'Round 4
''MD5R4 A,B,C,D, 0, 6, &HF4292244: A=eax
'MD5I(b,c,d)
asm mov edx,MD5D: asm not edx: asm or edx,MD5B
asm mov eax,MD5C: asm xor eax,edx
asm add eax,MD5A: asm add eax,[ebx]: asm add eax,0F4292244h
asm rol eax,6: asm add eax,MD5B: A=eax
''MD5R4 D,A,B,C, 7,10, &H432AFF97: D=eax
'MD5I(b,c,d)
asm mov edx,MD5C: asm not edx: asm or edx,MD5A
asm mov eax,MD5B: asm xor eax,edx
asm add eax,MD5D: asm add eax,[ebx+28]: asm add eax,432AFF97h
asm rol eax,10: asm add eax,MD5A: D=eax
''MD5R4 C,D,A,B,14,15, &HAB9423A7: C=eax
'MD5I(b,c,d)
asm mov edx,MD5B: asm not edx: asm or edx,MD5D
asm mov eax,MD5A: asm xor eax,edx
asm add eax,MD5C: asm add eax,[ebx+56]: asm add eax,0AB9423A7h
asm rol eax,15: asm add eax,MD5D: C=eax
''MD5R4 B,C,D,A, 5,21, &HFC93A039: B=eax
'MD5I(b,c,d)
asm mov edx,MD5A: asm not edx: asm or edx,MD5C
asm mov eax,MD5D: asm xor eax,edx
asm add eax,MD5B: asm add eax,[ebx+20]: asm add eax,0FC93A039h
asm rol eax,21: asm add eax,MD5C: B=eax
''MD5R4 A,B,C,D,12, 6, &H655B59C3: A=eax
'MD5I(b,c,d)
asm mov edx,MD5D: asm not edx: asm or edx,MD5B
asm mov eax,MD5C: asm xor eax,edx
asm add eax,MD5A: asm add eax,[ebx+48]: asm add eax,655B59C3h
asm rol eax,6: asm add eax,MD5B: A=eax
''MD5R4 D,A,B,C, 3,10, &H8F0CCC92: D=eax
'MD5I(b,c,d)
asm mov edx,MD5C: asm not edx: asm or edx,MD5A
asm mov eax,MD5B: asm xor eax,edx
asm add eax,MD5D: asm add eax,[ebx+12]: asm add eax,8F0CCC92h
asm rol eax,10: asm add eax,MD5A: D=eax
''MD5R4 C,D,A,B,10,15, &HFFEFF47D: C=eax
'MD5I(b,c,d)
asm mov edx,MD5B: asm not edx: asm or edx,MD5D
asm mov eax,MD5A: asm xor eax,edx
asm add eax,MD5C: asm add eax,[ebx+40]: asm add eax,0FFEFF47Dh
asm rol eax,15: asm add eax,MD5D: C=eax
''MD5R4 B,C,D,A, 1,21, &H85845DD1: B=eax
'MD5I(b,c,d)
asm mov edx,MD5A: asm not edx: asm or edx,MD5C
asm mov eax,MD5D: asm xor eax,edx
asm add eax,MD5B: asm add eax,[ebx+4]: asm add eax,85845DD1h
asm rol eax,21: asm add eax,MD5C: B=eax
''MD5R4 A,B,C,D, 8, 6, &H6FA87E4F: A=eax
'MD5I(b,c,d)
asm mov edx,MD5D: asm not edx: asm or edx,MD5B
asm mov eax,MD5C: asm xor eax,edx
asm add eax,MD5A: asm add eax,[ebx+32]: asm add eax,6FA87E4Fh
asm rol eax,6: asm add eax,MD5B: A=eax
''MD5R4 D,A,B,C,15,10, &HFE2CE6E0: D=eax
'MD5I(b,c,d)
asm mov edx,MD5C: asm not edx: asm or edx,MD5A
asm mov eax,MD5B: asm xor eax,edx
asm add eax,MD5D: asm add eax,[ebx+60]: asm add eax,0FE2CE6E0h
asm rol eax,10: asm add eax,MD5A: D=eax
''MD5R4 C,D,A,B, 6,15, &HA3014314: C=eax
'MD5I(b,c,d)
asm mov edx,MD5B: asm not edx: asm or edx,MD5D
asm mov eax,MD5A: asm xor eax,edx
asm add eax,MD5C: asm add eax,[ebx+24]: asm add eax,0A3014314h
asm rol eax,15: asm add eax,MD5D: C=eax
''MD5R4 B,C,D,A,13,21, &H4E0811A1: B=eax
'MD5I(b,c,d)
asm mov edx,MD5A: asm not edx: asm or edx,MD5C
asm mov eax,MD5D: asm xor eax,edx
asm add eax,MD5B: asm add eax,[ebx+52]: asm add eax,4E0811A1h
asm rol eax,21: asm add eax,MD5C: B=eax
''MD5R4 A,B,C,D, 4, 6, &HF7537E82: A=eax
'MD5I(b,c,d)
asm mov edx,MD5D: asm not edx: asm or edx,MD5B
asm mov eax,MD5C: asm xor eax,edx
asm add eax,MD5A: asm add eax,[ebx+16]: asm add eax,0F7537E82h
asm rol eax,6: asm add eax,MD5B: A=eax
''MD5R4 D,A,B,C,11,10, &HBD3AF235: D=eax
'MD5I(b,c,d)
asm mov edx,MD5C: asm not edx: asm or edx,MD5A
asm mov eax,MD5B: asm xor eax,edx
asm add eax,MD5D: asm add eax,[ebx+44]: asm add eax,0BD3AF235h
asm rol eax,10: asm add eax,MD5A: D=eax
''MD5R4 C,D,A,B, 2,15, &H2AD7D2BB: C=eax
'MD5I(b,c,d)
asm mov edx,MD5B: asm not edx: asm or edx,MD5D
asm mov eax,MD5A: asm xor eax,edx
asm add eax,MD5C: asm add eax,[ebx+8]: asm add eax,2AD7D2BBh
asm rol eax,15: asm add eax,MD5D: C=eax
''MD5R4 B,C,D,A, 9,21, &HEB86D391: B=eax
'MD5I(b,c,d)
asm mov edx,MD5A: asm not edx: asm or edx,MD5C
asm mov eax,MD5D: asm xor eax,edx
asm add eax,MD5B: asm add eax,[ebx+36]: asm add eax,0EB86D391h
asm rol eax,21: asm add eax,MD5C: B=eax
    
IADD(A,AA): IADD(B,BB): IADD(C,CC): IADD(D,DD)
end while  'Next iter

''Step 5.  Output the 128 bit digest
end use dat
byteswap(A): byteswap(B): byteswap(C): byteswap(D)
X=hex$(A)+hex$(B)+hex$(C)+hex$(D)
result=X
End Function
