'MD5.inc Copyright 2007 James J Keene
'Updated Oct 21, 2007
'based on RFC 1321

'Usage: MyString = MD5(objptr(stream))
'where stream is a STRING or FILE instance

declare function MD5 (MD5In as long) as string
declare sub MD5F (x as long, y as long, z as long)
declare sub MD5G (x as long, y as long, z as long)
declare sub MD5H (x as long, y as long, z as long)
declare sub MD5I (x as long, y as long, z as long)
declare sub MD5R1 (a as long, b as long, c as long, d as long,_
  Xk as long, Sl as long, Ti as long)
declare sub MD5R2 (a as long, b as long, c as long, d as long,_
  Xk as long, Sl as long, Ti as long)
declare sub MD5R3 (a as long, b as long, c as long, d as long,_
  Xk as long, Sl as long, Ti as long)
declare sub MD5R4 (a as long, b as long, c as long, d as long,_
  Xk as long, Sl as long, Ti as long)

'=====
function MD5
defint i,k,datEnd
defint64 i64
defbyte b0
defint A,B,C,D,AA,BB,CC,DD
defstr X

use dat as FILE with MD5In
''Step 1 Part A
i=dat.size: i64 = i*8

''Step 3
A = &H67452301
B = &HEFCDAB89
C = &H98BADCFE
D = &H10325476

''Step 4.  Process the message in 16-word blocks
dat.position=zero: datEnd=2
while datEnd
X = dat.readstr(64)

IF X.len < 64 THEN  'oops, this is the end!
''Step 1 Part B: padding
  if datEnd=2 then b0 = &H80: X.write(b0): dec(datEnd)
  b0 = zero
  if X.len<=56 then k=55 else k=63
  for i=X.len to k: X.write(b0): next i
''Step 2
  if X.len=56 then X.write(i64): datEnd=zero
END IF

AA = A
BB = B
CC = C
DD = D

'Round 1
MD5R1 A,B,C,D, 0, 7, &HD76AA478: A=eax
MD5R1 D,A,B,C, 1,12, &HE8C7B756: D=eax
MD5R1 C,D,A,B, 2,17, &H242070DB: C=eax
MD5R1 B,C,D,A, 3,22, &HC1BDCEEE: B=eax
MD5R1 A,B,C,D, 4, 7, &HF57C0FAF: A=eax
MD5R1 D,A,B,C, 5,12, &H4787C62A: D=eax
MD5R1 C,D,A,B, 6,17, &HA8304613: C=eax
MD5R1 B,C,D,A, 7,22, &HFD469501: B=eax
MD5R1 A,B,C,D, 8, 7, &H698098D8: A=eax
MD5R1 D,A,B,C, 9,12, &H8B44F7AF: D=eax
MD5R1 C,D,A,B,10,17, &HFFFF5BB1: C=eax
MD5R1 B,C,D,A,11,22, &H895CD7BE: B=eax
MD5R1 A,B,C,D,12, 7, &H6B901122: A=eax
MD5R1 D,A,B,C,13,12, &HFD987193: D=eax
MD5R1 C,D,A,B,14,17, &HA679438E: C=eax
MD5R1 B,C,D,A,15,22, &H49B40821: B=eax
      
'Round 2
MD5R2 A,B,C,D, 1, 5, &HF61E2562: A=eax
MD5R2 D,A,B,C, 6, 9, &HC040B340: D=eax
MD5R2 C,D,A,B,11,14, &H265E5A51: C=eax
MD5R2 B,C,D,A, 0,20, &HE9B6C7AA: B=eax
MD5R2 A,B,C,D, 5, 5, &HD62F105D: A=eax
MD5R2 D,A,B,C,10, 9, &H02441453: D=eax
MD5R2 C,D,A,B,15,14, &HD8A1E681: C=eax
MD5R2 B,C,D,A, 4,20, &HE7D3FBC8: B=eax
MD5R2 A,B,C,D, 9, 5, &H21E1CDE6: A=eax
MD5R2 D,A,B,C,14, 9, &HC33707D6: D=eax
MD5R2 C,D,A,B, 3,14, &HF4D50D87: C=eax
MD5R2 B,C,D,A, 8,20, &H455A14ED: B=eax
MD5R2 A,B,C,D,13, 5, &HA9E3E905: A=eax
MD5R2 D,A,B,C, 2, 9, &HFCEFA3F8: D=eax
MD5R2 C,D,A,B, 7,14, &H676F02D9: C=eax
MD5R2 B,C,D,A,12,20, &H8D2A4C8A: B=eax
     
'Round 3
MD5R3 A,B,C,D, 5, 4, &HFFFA3942: A=eax
MD5R3 D,A,B,C, 8,11, &H8771F681: D=eax
MD5R3 C,D,A,B,11,16, &H6D9D6122: C=eax
MD5R3 B,C,D,A,14,23, &HFDE5380C: B=eax
MD5R3 A,B,C,D, 1, 4, &HA4BEEA44: A=eax
MD5R3 D,A,B,C, 4,11, &H4BDECFA9: D=eax
MD5R3 C,D,A,B, 7,16, &HF6BB4B60: C=eax
MD5R3 B,C,D,A,10,23, &HBEBFBC70: B=eax
MD5R3 A,B,C,D,13, 4, &H289B7EC6: A=eax
MD5R3 D,A,B,C, 0,11, &HEAA127FA: D=eax
MD5R3 C,D,A,B, 3,16, &HD4EF3085: C=eax
MD5R3 B,C,D,A, 6,23, &H04881D05: B=eax
MD5R3 A,B,C,D, 9, 4, &HD9D4D039: A=eax
MD5R3 D,A,B,C,12,11, &HE6DB99E5: D=eax
MD5R3 C,D,A,B,15,16, &H1FA27CF8: C=eax
MD5R3 B,C,D,A, 2,23, &HC4AC5665: B=eax
    
'Round 4
MD5R4 A,B,C,D, 0, 6, &HF4292244: A=eax
MD5R4 D,A,B,C, 7,10, &H432AFF97: D=eax
MD5R4 C,D,A,B,14,15, &HAB9423A7: C=eax
MD5R4 B,C,D,A, 5,21, &HFC93A039: B=eax
MD5R4 A,B,C,D,12, 6, &H655B59C3: A=eax
MD5R4 D,A,B,C, 3,10, &H8F0CCC92: D=eax
MD5R4 C,D,A,B,10,15, &HFFEFF47D: C=eax
MD5R4 B,C,D,A, 1,21, &H85845DD1: B=eax
MD5R4 A,B,C,D, 8, 6, &H6FA87E4F: A=eax
MD5R4 D,A,B,C,15,10, &HFE2CE6E0: D=eax
MD5R4 C,D,A,B, 6,15, &HA3014314: C=eax
MD5R4 B,C,D,A,13,21, &H4E0811A1: B=eax
MD5R4 A,B,C,D, 4, 6, &HF7537E82: A=eax
MD5R4 D,A,B,C,11,10, &HBD3AF235: D=eax
MD5R4 C,D,A,B, 2,15, &H2AD7D2BB: C=eax
MD5R4 B,C,D,A, 9,21, &HEB86D391: B=eax
    
IADD(A,AA): IADD(B,BB): IADD(C,CC): IADD(D,DD)
end while  'Next iter

''Step 5.  Output the 128 bit digest
end use dat
byteswap(A): byteswap(B): byteswap(C): byteswap(D)
X=hex$(A)+hex$(B)+hex$(C)+hex$(D)
result=X
End Function

'=====result in eax
sub MD5F '(x & y) | (~x & z)
asm mov eax,x: asm and eax,y
asm mov edx,x: asm not edx: asm and edx,z
asm or eax,edx
end sub

sub MD5G  '(x & z) | (y & ~z)
asm mov eax,x: asm and eax,z
asm mov edx,z: asm not edx: asm and edx,y
asm or eax,edx
end sub

sub MD5H  'x xor y xor z
asm mov eax,x: asm xor eax,y: asm xor eax,z
end sub

sub MD5I  'y xor (x | ~z)
asm mov edx,z: asm not edx: asm or edx,x
asm mov eax,y
asm xor eax,edx
end sub

'=====result in eax
sub MD5R1
MD5X.position=IMUL(Xk,4): MD5X.read(Xk)  'reuse Xk arg as X data
MD5F(b,c,d): asm add eax,a: asm add eax,Xk: asm add eax,Ti
asm mov ecx,Sl: asm db 0d3h,0c0h  'asm rol eax,cl
asm add eax,b
end sub

sub MD5R2
MD5X.position=IMUL(Xk,4): MD5X.read(Xk)  'reuse Xk arg as X data
MD5G(b,c,d): asm add eax,a: asm add eax,Xk: asm add eax,Ti
asm mov ecx,Sl: asm db 0d3h,0c0h  'asm rol eax,cl
asm add eax,b
end sub

sub MD5R3
MD5X.position=IMUL(Xk,4): MD5X.read(Xk)  'reuse Xk arg as X data
MD5H(b,c,d): asm add eax,a: asm add eax,Xk: asm add eax,Ti
asm mov ecx,Sl: asm db 0d3h,0c0h  'asm rol eax,cl
asm add eax,b
end sub

sub MD5R4
MD5X.position=IMUL(Xk,4): MD5X.read(Xk)  'reuse Xk arg as X data
MD5I(b,c,d): asm add eax,a: asm add eax,Xk: asm add eax,Ti
asm mov ecx,Sl: asm db 0d3h,0c0h  'asm rol eax,cl
asm add eax,b
end sub
