'PrintDev.inc Copyright 2004 James J. Keene
'Updated: Mar 31, 2007

'This include extends the HotBasic PRINTER OBJECT
'to facilitate RW of DevMode properties

OBJECT PrintDev EXTENDS PRINTER
DeviceName As STRING*32  'start with DEVMODE structure
SpecVersion As WORD 
DriverVersion As WORD
PrtSize As WORD
DriverExtra As WORD 
Fields As LONG 
Orientation As SHORT 
PaperSize As SHORT 
PaperLength As SHORT 
PaperWidth As SHORT 
Scale As SHORT 
Copies As SHORT 
DefaultSource As SHORT 
PrintQuality As SHORT 
Color As SHORT 
Duplex As SHORT 
YResolution As SHORT 
TTOption As SHORT
Collate As SHORT 
FormName As STRING*46 
LogPixels As WORD 
BitsPerPel As LONG 
PelsWidth As LONG 
PelsHeight As LONG 
DisplayFlags As LONG 
DisplayFrequency As LONG 
'ICMMethod As LONG  'W95 only 
'ICMIntent As LONG  'W95 only
'MediaType As LONG  'W95 only
'DitherType As LONG 'W95 only
'Reserved1 As LONG  'W95 only
'Reserved2 As LONG  'W95 only
Default As STRING*32 'start of DevNames data
Device As STRING*32  'probably same as DevName
Output As STRING*8
Driver As STRING*8
GetDevMode As SUB
SetDevMode As SUB
GetDevNames As SUB
SetDevNames As SUB
ResetDC As SUB
END PrintDev

DEFINT DM_SIZE = 138
DEFSTR DevMode = STRING$(DM_SIZE,CHR$(0))
DEFSTR DevNames = STRING$(104,CHR$(0))

DECLARE SUB GetDevMode
DECLARE SUB SetDevMode
DECLARE SUB GetDevNames
DECLARE SUB SetDevNames
DECLARE SUB ResetDC
DECLARE SUB GetObjStr (offset as LONG)
DECLARE FUNCTION SetObjStr (offset as LONG, maxlen as LONG) as STRING

SUB GetDevMode
defint i
IF NOT PRINTER.DevMode THEN
  i=PRINTER.Flags: PUSH i
  PRINTER.Flags=&H400: i=PRINTER.Execute
  POP i: PRINTER.Flags=i
END IF
DevMode.LoadFromHandle PRINTER.DevMode, DM_SIZE
memcpy hbObj, @DevMode, DM_SIZE
END SUB

SUB ResetDC
begin runonce
DECLARE SUB ResetDCA LIB "gdi32" (pDC AS LONG, devmodedata AS LONG)
end runonce
ResetDCA PRINTER.DC, byref(PRINTER.DevMode)
END SUB

SUB SetDevMode
memcpy @DevMode, hbObj, DM_SIZE
PRINTER.DevMode = DevMode.Handle
END SUB

SUB GetDevNames
DEFWORD W
DEFSTR S
IF PRINTER.DevNames THEN
  DevNames.LoadFromHandle PRINTER.DevNames, 88
  DevNames.Position = zero
  DevNames.Read(W): INC(W): S = MID$(DevNames,W,8)
  GetObjStr DM_SIZE+72  'Driver
  DevNames.Position = 2
  DevNames.Read(W): INC(W): S = MID$(DevNames,W,32)
  GetObjStr DM_SIZE+32  'Device
  DevNames.Position = 4
  DevNames.Read(W): INC(W): S = MID$(DevNames,W,8)
  GetObjStr DM_SIZE+64  'Output
  DevNames.Position = 6
  DevNames.Read(W): INC(W): S = MID$(DevNames,W,32)
  GetObjStr DM_SIZE  'Default
ELSE
  memset hbObj+DM_SIZE+8, 96, zero  'clear if .DevNames=0
END IF
END SUB

SUB SetDevNames
DIM S(3) as STRING*32
DEFSTR c0 = CHR$(0)
DEFWORD W
S(0) = SetObjStr(DM_SIZE, 32)    'Default
S(1) = SetObjStr(DM_SIZE+72, 8)  'Driver
S(2) = SetObjStr(DM_SIZE+32, 32) 'Device
S(3) = SetObjStr(DM_SIZE+64, 8)  'Output
DevNames = STRING$(8,c0) +  S(0) + c0 + _
  S(1) + c0 + S(2) + c0 + S(3) + c0
DevNames.Position = zero
W = 9 + LEN(S(0)): DevNames.Write(W)
W = W + LEN(S(1))+1: DevNames.Write(W)
W = W + LEN(S(2))+1: DevNames.Write(W)
W = 8: DevNames.Write(W)  '.Default offset
PRINTER.DevNames = DevNames.Handle
END SUB

SUB GetObjStr (offset as LONG)
memcpy hbObj+offset, @GetDevNamesS, LEN(GetDevNamesS)+1
END SUB

FUNCTION SetObjStr (offset as LONG, maxlen as LONG) as STRING
DEFSTR S$ = STRING$(32,CHR$(0))
memcpy @S$, hbObj+offset, maxlen
Result = LEFT$(S$,LEN(S$)) 
END FUNCTION
