'RichGrid.inc Copyright 2005-2010 James J Keene
'Updated: July 16, 2010

'This include extends the HotBasic GRID Object.

'It is a work in progress.
'Thus far, you can get click cell row/colum and
'edit any valid cell with right click.
'Almost all LISTVIEW/GRID type structures are provided
'for easy read/write access and use in additions.
'SUBS and FUNCTIONS can be added to develop further.

defLNG rgEdit   'Edit handle
defLNG rgEditOn 'non-zero when editing cell
defLNG rgi,rgj,rgk,rgADDR,rgROW,rgCOL 'scratch vars
dim rgObj(1,9) as LONG  'for instance database
defstr rgSTR  'scratch string

OBJECT RichGrid EXTENDS GRID

'LV_ITEM at offset = 0:
ItemMask As LONG
ItemRow As LONG  '0-based row item
ItemCol As LONG  '0-based col SubItem
ItemState As LONG
StateMask As LONG
ItemText As LONG  'pointer
ItemTextLen As LONG
ItemImage As LONG
ItemTag As LONG

'LV_COLUMN at offset = 36:
'LVM_GETCOLUMN, LVM_SETCOLUMN, LVM_INSERTCOLUMN, LVM_DELETECOLUMN
ColMask As LONG
ColFormat As LONG
ColWidth As LONG
ColText As LONG  'pointer
ColTextLen As LONG
Column As LONG  '0-based column

'LV_FINDINFO at offset = 60
FindFlags As LONG
FindText As LONG
FindTag As LONG
FindX As LONG
Direction As LONG = &H28  'VK_DOWN

'LV_HITTESTINFO at offset = 80
HitX As LONG
HitY As LONG
HitFlags As LONG = 14 'LVHT_ONITEM
HitItem As LONG

'RECT object at offset = 96
Left As LONG
Top As LONG
Right As LONG
Bottom As LONG

'Misc. variables at offset = 112
Rows As LONG  '0-based values here
Columns As LONG
LastRows As LONG
LastColumns As LONG
SelRow As LONG
SelCol As LONG
EditColor As Long = &Hccffff 'yellow

'add custom procedures here
END RichGrid

DECLARE SUB RICHGRID_Init
DECLARE SUB RICHGRIDRows_Set
DECLARE SUB RICHGRIDColumns_Set

SUB RICHGRID_Init 'can handle up to 10 instances
DEFINT n
BEGIN RUNONCE
rgEdit=createobj(EDIT)
window(rgEdit).ExStyle=8 'WS_EX_TOPMOST
window(rgEdit).visible=false
window(rgEdit).onkeyup=rg_edit_keyup
END RUNONCE
window(hbHnd).OnMessage=rg_msg
'set up database for each instance created
IF n > 9 THEN
  showmessage "ERROR: More than 10 instances."
  App.terminate
END IF
rgObj(0,n)=hbHnd: rgObj(1,n)=hbObj: INC(n)
END SUB

SUB RICHGRIDRows_Set
rgj=self.LastRows: rgk=self.Rows
IF rgk > rgj THEN
  rgi=sendmessage(hbHnd,4143,rgk,zero)  'LVM_SETITEMCOUNT
  FOR rgi = rgj to rgk
  window(hbHnd,GRID).insertrow rgi,null
  NEXT rgi
ELSE
  self.Rows = rgj 'can't reduce number of rows
END IF
self.LastRows = rgk
END SUB

SUB RICHGRIDColumns_Set
rgj=self.LastColumns: rgk=self.Columns
IF rgk > rgj THEN
  FOR rgi = rgj to rgk
  window(hbHnd,GRID).insertcol rgi,chr$(65+rgi)
  NEXT rgi
ELSE
  self.Columns = rgj 'can't reduce number of columns
END IF
self.LastColumns = rgk
END SUB

'Custom Object routines above; Event routines below
Goto RICHGRID_End  'jump past undeclared subs

rg_msg:
IF rgEditOn THEN window(rgEdit).focus: return
nCode = BYREF(iadd(lParam,8))
'IF nCode=-108 THEN 'column button clicked
'your code here
'END IF
IF nCode=-2 OR nCode=-5 THEN 'NM_CLICK or NM_RCLICK
  gosub rg_get_instance
  IF rgADDR THEN  'error check; OK if not zero
  'here, a trick to use Custom Object syntax in an Event routine:
    push hbObj: hbObj=rgADDR 'save and change hbObj value
    self.SelCol=byref(iadd(lParam,16))
    rgi=byref(iadd(lParam,12))
    'if click on subitem, row rgi is wrong, always -1!! Nuts!
    'below, we check for -1 and calculate item (row) when needed.
    IF rgi<zero THEN
       rgi=sendmessage(hWnd,4135,zero,zero) 'LVM_GETTOPINDEX
       rgj=sendmessage(hWnd,4110,rgi,@RICHGRID.Left) 'LVM_GETITEMRECT
       rgk=self.Bottom-self.Top 'get height
       rgj=window(hWnd).mousey: idiv(rgj,rgk): dec(rgj)
       iadd(rgi,rgj)
    END IF
    self.SelRow=rgi: DoEvents
    IF nCode=-5 THEN 'RCLICK means we want to edit!
      INC(rgEditOn) 'set Editing On flag
'      window(hWnd).Enabled=zero 'turn off
      defint rgHandle=hWnd 'save grid handle
      rgROW=self.SelRow: rgCOL=self.SelCol 'Save for Edit sub
      rgk=sendmessage(hWnd,4110,rgi,@RICHGRID.Left) 'get RECT
      window(rgEdit).left=self.Left+window(hWnd).left
      window(rgEdit).top=self.Top+window(hWnd).top
      window(rgEdit).width=self.Right-self.Left
      window(rgEdit).height=self.Bottom-self.Top
      rgSTR=window(hWnd,GRID).cell(rgROW,rgCOL)
      window(rgEdit).text=rgSTR: doevents
      window(rgEdit).color=self.EditColor
      window(rgEdit).visible=true
      window(rgEdit).focus
    ELSE  'NM_CLICK
      rgi=window(hWnd).OnClick 'get grid .OnClick
      IF rgi THEN callfunc rgi
    END IF
    pop hbObj 'restore hbObj value
  END IF
END IF

rg_msg_end:
RETVAL zero
RETURN

rg_get_instance:
rgADDR=zero 'if zero, this sub failed to find address
For rgi=0 to RICHGRID_Initn - 1
IF rgObj(0,rgi)=hWnd THEN rgADDR=rgObj(1,rgi): Exit FOR
NEXT rgi
RETURN

rg_edit_keyup:
IF wParam=27 THEN goto rg_edit_escape
IF wParam=13 THEN  'end Edit if RETURN
  rgSTR=window(rgEdit).text
  window(rgHandle,GRID).cell(rgROW,rgCOL)=rgSTR
  doevents
  rg_edit_escape:  'don't save edit results
  window(rgEdit).visible=false
  rgEditOn=zero
'  window(rgHandle).Enabled=true 'OnMessage=rg_msg 'turn on
  window(rgHandle).focus
END IF
return

RICHGRID_End:
