'ShellEx.inc Copyright 2004-2009 James J Keene
'Updated: Jan 24, 2009

'ShellEx.inc provides full RW access to CreateProcessA
'arguments, STARTUPINFO and PROCESS_INFORMATION items.
'Thus, any conceivable RUN/SHELL of a child process can
'be implemented in HotBasic applications.

'.CreationFlags constants:
'$DEFINE DEBUG_PROCESS 1
'$DEFINE DEBUG_ONLY_THIS_PROCESS 2
'$DEFINE CREATE_SUSPENDED 4
'$DEFINE DETACHED_PROCESS 8
'$DEFINE CREATE_NEW_CONSOLE &H10
'$DEFINE CREATE_DEFAULT_ERROR_MODE
'$DEFINE CREATE_NEW_PROCESS_GROUP &H200
'$DEFINE CREATE_SEPARATE_WOW_VDM &H800
'$DEFINE CREATE_SHARED_WOW_VDM
'$DEFINE CREATE_UNICODE_ENVIORONMENT

'$DEFINE NORMAL_PRIORITY_CLASS &H20
'$DEFINE IDLE_PRIORITY_CLASS &H40
'$DEFINE HIGH_PRIORITY_CLASS &H80
'$DEFINE REALTIME_PRIORITY_CLASS &H100

'STARTUPINFO .Flags constants:
'$DEFINE STARTF_USESHOWWINDOW 1
'$DEFINE STARTF_USESIZE 2
'$DEFINE STARTF_USEPOSITION 4
'$DEFINE STARTF_USECOUNTCHARS 8
'$DEFINE STARTF_USEFILLATTRIBUTE &H10
'$DEFINE STARTF_RUNFULLSCREEN &H20
'$DEFINE STARTF_FORCEONFEEDBACK &H40
'$DEFINE STARTF_FORCEOFFFEEDBACK &H80
'$DEFINE STARTF_USESTDHANDLES &H100

'STARTUPINFO .ShowWindow constants:
'$DEFINE SW_HIDE 0
'$DEFINE SW_NORMAL 1
'$DEFINE SW_SHOWMINIMIZED 2
'$DEFINE SW_MAXIMIZE 3
'$DEFINE SW_SHOWNOACTIVATE 4
'$DEFINE SW_SHOW 5
'$DEFINE SW_MINIMIZE 6
'$DEFINE SW_SHOWMINNOACTIVE 7
'$DEFINE SW_SHOWNA 8
'$DEFINE SW_RESTORE 9
'$DEFINE SW_SHOWDEFAULT 10

OBJECT ShellEx
'CreateProcess arguments
AppName As LONG
CmdLine As LONG
ProcAttr As LONG
ThreadAttr As LONG
Inherit As LONG = 1  'true
CreationFlags As LONG = 32  'normal priority
Environ As LONG
CurDir As LONG
S_info As LONG
P_info As LONG

'STARTUPINFO offset = 40
S_size As LONG = 98
Reserved1 As LONG
Desktop As LONG
Title As LONG
X As LONG
Y As LONG
XSize As LONG
YSize As LONG
XCountChars As LONG
YCountChars As LONG
FillAttribute As LONG
Flags As LONG
ShowWindow As WORD
cbReserved2 As WORD
Reserved2 As LONG
hStdInput As LONG
hStdOutput As LONG
hStdError As LONG

'PROCESS_INFORMATION offset = 108
hProcess As LONG
hThread As LONG
ProcessId As LONG
ThreadId As LONG

'more properties offset = 124
ExitCode As LONG

'methods and functions
ShellExe AS SUB
RunExe AS SUB

END ShellEx

Declare SUB SHELLEX_Init
Declare SUB get_cmd_line
Declare SUB call_cp
Declare SUB RunExe(cmd$ As STRING) 
Declare SUB ShellExe(cmd$ As STRING)

SUB SHELLEX_Init  'called on dim
self.S_info=@SHELLEX.S_size   'S_info=lpSTARTUPINFO
self.P_info=@SHELLEX.hProcess 'P_info=lpPROCESS_INFORMATION
END SUB

SUB get_cmd_line
self.CmdLine=@cmd$  'pointer to command line
END SUB

SUB call_cp
ASM mov esi,hbObj
ASM add esi,36
cp_arg:
ASM push [esi]
ASM sub esi,4
ASM cmp esi,hbObj
ASM jge cp_arg
ASM call CreateProcessA
END SUB

SUB RunExe(cmd$ As STRING) 
get_cmd_line: call_cp 
END SUB

SUB ShellExe(cmd$ As STRING)
get_cmd_line: call_cp
shell_wait:
SLEEP 0.01  'wait 10 msec
FUNCCALL GetExitCodeProcess, self.hProcess, @SHELLEX.ExitCode
IF self.ExitCode = &H103 THEN Goto shell_wait
END SUB

