'ShowPage.inc Copyright 2004-2006 James J. Keene
'Updated: Feb 7, 2007

'This include provides a generic method to select what is shown on
'the screen by nothing more than an index for the "page" (or group) of
'items to be displayed.  Thus, different objects may be displayed in the
'same window area at different times.

'The SetPage SUB registers an object item as belonging to a particular
'display index or page.

'The ShowPage SUB selects among any number of different screen displays,
'in whole or in part, and this concept may be used in a TABCONTROL
'object or whenever we want easy manipulation of which items are displayed.

'First, assign objects to display pages with SetPage.  Any object may
'appear on one or more pages.

'Second, use ShowPage to select which group of items is displayed.

$DEFINE nObjects 50  'make nObjects fit what you need
$DEFINE wpage    0   'array subscript for page ID
$DEFINE whandle  1   'array subscript for object handle

DEFINT iObject = -1
DEFINT ShowPageLast = -1
DIM pagedat(1,nObjects) As LONG

DECLARE SUB SetPage(ipage As LONG, ihandle As LONG)
DECLARE SUB ShowPage(ipage As LONG)

'associate object handle with a visible page

SUB SetPage(ipage As LONG, ihandle As LONG)
INC(iObject)
IF iObject > nObjects THEN SHOWMESSAGE "ReDimension # objects": Exit Sub
pagedat(wpage,iObject) = ipage: pagedat(whandle,iObject) = ihandle
callfunc ShowWindow,zero,ihandle  'set item invisible
END SUB

'make ipage objects visible

SUB ShowPage(ipage As LONG)
DEFINT r, i, j
IF r THEN RETURN ELSE INC(r)
IF iObject < zero THEN SHOWMESSAGE "No objects assigned to pages": Exit Sub
'first we make not visible if visible and not ipage
FOR i = zero to iObject
  j = pagedat(wpage,i)
  IF j <> ipage and j = ShowPageLast THEN
    callfunc ShowWindow,zero,pagedat(whandle,i)
  END IF
NEXT i

'maybe not necessary but we make visible as last step
FOR i = zero to iObject
  IF pagedat(wpage,i) = ipage THEN
    callfunc ShowWindow,1,pagedat(whandle,i)  'ihandle
  END IF
NEXT i
r=zero: ShowPageLast = ipage  'remember last page shown
END SUB

$UNDEF nObjects, wpage, whandle

'code to assign an object (MyObject) with a display (n):

'SetPage n, MyObject  'where n is 0 to ?? page.

'as a result of an event or whenever,
'when we wish to show a page of objects, then

'ShowPage n  'where n is 0 to ?? page (or selected tab).

'Performance may be improved if the .Redraw property of the form is
'turned off (false) and then on again (true) before and after ShowPage
'is called respectively, to prevent redrawing during the ShowPage SUB.
