'Splitter.inc Copyright 2006 James J. Keene
'Updated: Mar 31, 2007

OBJECT SPLITTER EXTENDS PANEL
Vertical As LONG = 1
RangeLeft As LONG   '4 values define drag range
RangeTop As LONG
RangeWidth As LONG  'defaults to Parent ClientWidth
RangeHeight As LONG 'defaults to Parent ClientHeight
LeftTop1 As LONG
LeftTop2 As LONG
LeftTop3 As LONG     'up to 3 buddies allocated
RightBottom1 As LONG
RightBottom2 As LONG
RightBottom3 As LONG 'up to 3 buddies allocated
Init as SUB
down as SUB
up as SUB
END SPLITTER

declare sub SPLITTERInit
declare sub SPLITTERdown
declare sub SPLITTERup

$DEFINE SPLITTERdim 4

sub SPLITTERInit
defint n
window(hbHnd).Tag = hbObj  'save SPLITTER address
IF BYREF(hbObj) THEN  'vertical if true
  window(hbHnd).Width = SPLITTERdim
ELSE
  window(hbHnd).Height = SPLITTERdim
END IF
window(hbHnd).cursor = 32646 'IDC_SIZEALL
'set up event handler addresses
window(hbHnd).OnMouseDown = SPLITTERdown
window(hbHnd).OnMouseUp = SPLITTERup
n = window(hbHnd).Parent
window(n).Style = window(n).Style OR &H2000000  'WS_CLIPCHILDREN
window(hbHnd).Style = window(hbHnd).Style OR &H4000000  'WS_CLIPSIBLINGS
end sub

sub SPLITTERdown
defint i, p1, p2, h1, h2, n, s, a, W, H, drag
defint d, x0, y0, x1, y1, x2, y2
IF drag THEN return
INC(drag): s = hWnd
a = window(s).Tag  'get SPLITTER address
IF not a THEN SHOWMESSAGE "Missing SPLITTER Init statement": App.Terminate
IF BYREF(a) THEN  'vertical if true
  window(s).Cursor = 32644 'IDC_SIZEWE
ELSE
  window(s).Cursor = 32645 'IDC_SIZENS
END IF
DOEVENTS
x0 = BYREF(a+4)  '.RangeLeft
y0 = BYREF(a+8)  '.RangeTop
n = window(s).parent
W = BYREF(a+12)  '.RangeWidth
IF NOT W ThEN W = window(n).clientwidth: BYREF(a+12) = W 
DEC(W, SPLITTERdim)
H = BYREF(a+16)  '.RangeHeight
IF NOT H THEN H = window(n).clientheight: BYREF(a+16) = H 
DEC(H, SPLITTERdim)
DOEVENTS
x1 = mouse.x: y1 = mouse.y

'begin drag loop
WHILE drag
DOEVENTS
x2 = mouse.x: y2 = mouse.y
'get change in position in d
IF BYREF(a) THEN  'vertical if true
  d = x2 - x1
  IF NOT d THEN Goto SPLITTER_sleep
  n = window(s).Left + d
  IF n >= x0 and n < W THEN _
    window(s).Left = n ELSE Exit While
ELSE
  d = y2 - y1
  IF NOT d THEN Goto SPLITTER_sleep
  n = window(s).Top + d
  IF n >= y0 and n < H THEN _
    window(s).Top = n ELSE Exit While
END IF
x1 = x2: y1 = y2
DOEVENTS
'get pointers to "buddy handles"
p1 = a + 20  'pointer to .LeftTop1
p2 = a + 32  'pointer to .RightBottom1 
FOR i = zero TO 8 STEP 4
'get buddy handles
h1 = BYREF(p1+i): h2 = BYREF(p2+i)
IF BYREF(a) THEN  'vertical if true
  IF h1 THEN
    n = window(h1).width + d
    IF n >= zero then window(h1).width = n
  END IF
  IF h2 THEN
    IF d > zero THEN
      gosub h2left: gosub h2width
    ELSE
      gosub h2width: gosub h2left
    END IF 
    window(h2).repaint
  END IF
ELSE
  IF h1 THEN
    n = window(h1).height + d
    IF n >= zero then window(h1).height = n
  END IF
  IF h2 THEN
    IF d > zero THEN
      gosub h2top: gosub h2height
    ELSE
      gosub h2height: gosub h2top
    END IF 
    window(h2).repaint
  END IF
END IF
DOEVENTS
NEXT i
SPLITTER_sleep:
SLEEP 0.08
DOEVENTS
END WHILE

SPLITTER_stop:
drag = zero
window(s).cursor = 32646
exit sub

h2width:
n = window(h2).width - d
IF n >= zero then window(h2).width = n  ': window(h2).repaint
return

h2left:
n = window(h2).left + d
IF n > zero then window(h2).left = n
return

h2height:
n = window(h2).height - d
IF n >= zero then window(h2).height = n  ': window(h2).repaint
return

h2top:
n = window(h2).top + d
IF n > zero then window(h2).top = n
return

end sub

sub SPLITTERup
SPLITTERdowns = hWnd  'reference to SPLITTERdown local var s
Goto SPLITTER_stop
end sub

'$UNDEF SPLITTERdim
