'cor.inc Copyright 2012 James J Keene
'computes product-moment correlation

'Xptr and Yptr are array pointers to one-dimensional numeric arrays.
'r1 and r2 are the first and last array indices to use. Example:

'DIM A(99) as double, B(99) as double
'defint Aptr=objptr(A)
'defint Bptr=objptr(B)
'code to put values in A and B
'defdbl r = cor(Aptr,Bptr,0,99) 'compute correlation r
'Note: r^2 is percent shared variance between A and B.

declare function cor_
  (Xptr as long, Yptr as long, r1 as long, r2 as long) as real10

function cor
defreal10 x,y,z,Ex,Ey,Ex2,Ey2,Exy
defint I,N=zero
Ex=zero: Ey=zero: Ex2=zero: Ey2=zero: Exy=zero
for I=r1 to r2: inc(N)
x=arrayref(Xptr,I): y=arrayref(Yptr,I)
Ex=Ex+x: Ey=Ey+y: Ex2=Ex2+x*x: Ey2=Ey2+y*y: Exy=Exy+x*y
next I
x=Exy-(Ex*Ey)/N  'numerator
y=Ex2-Ex*Ex/N: z=Ey2-Ey*Ey/N: y=y*z  'denominator
result=zero  'note exact zero result is probably error
if y>zero then result=x/sqr(y)
end function
 