'debugger.inc Copyright 2007 James J Keene
'Updated: June 18, 2007

'DEBUG_EVENT code values:
$DEFINE EXCEPTION_DEBUG_INFO 1
$DEFINE CREATE_THREAD_DEBUG_INFO 2
$DEFINE CREATE_PROCESS_DEBUG_INFO 3
$DEFINE EXIT_THREAD_DEBUG_INFO 4
$DEFINE EXIT_PROCESS_DEBUG_INFO 5
$DEFINE LOAD_DLL_DEBUG_INFO 6
$DEFINE UNLOAD_DLL_DEBUG_INFO 7
$DEFINE OUTPUT_DEBUG_STRING_INFO 8
$DEFINE RIP_INFO 9

TYPE DEBUG_EVENT
code as long
ProcessId as long
ThreadId as long
union as string*40  'types shown below
END DEBUG_EVENT

TYPE EXCEPTION_DEBUG_INFO  'Exception
code as long  'begin EXCEPTION_RECORD
flags as long
lpRecord as long
address as long
nparams as long
lpInfoArray as long  'end EXCEPTION_RECORD
FirstChance as long
END EXCEPTION_DEBUG_INFO

TYPE CREATE_THREAD_DEBUG_INFO  'CreateThread
hThread as long
lpThreadLocalBase as long
lpStartAddress as long
END CREATE_THREAD_DEBUG_INFO

TYPE CREATE_PROCESS_DEBUG_INFO  'CreateProcessInfo
hFile as long  'use to read/write .exe
hProcess as long  'use to read/write ram
hThread as long  'use to read/write registers
lpBaseOfImage as long
DebugInfoFileOffset as long  'CodeView 4.0 format
nDebugInfoSize as long
lpThreadLocalBase as long
lpStartAddress as long
lpImageName as long  'filename of hFile above
Unicode as word  '1=unicode else 0
END CREATE_PROCESS_DEBUG_INFO

TYPE EXIT_THREAD_DEBUG_INFO  'ExitThread
ExitCode as long
END EXIT_THREAD_DEBUG_INFO

TYPE EXIT_PROCESS_DEBUG_INFO  'ExitProcess
ExitCode as long
END EXIT_PROCESS_DEBUG_INFO

TYPE LOAD_DLL_DEBUG_INFO  'LoadDll
hFile as long
lpBaseOfDll as long
DebugInfoFileOffset as long
DebugInfoSize as long
lpImageName as long
Unicode as word
END LOAD_DLL_DEBUG_INFO

TYPE UNLOAD_DLL_DEBUG_INFO  'UnloadDll
lpBaseOfDll as long
END UNLOAD_DLL_DEBUG_INFO

TYPE OUTPUT_DEBUG_STRING_INFO  'DebugString
lpDebugStringData as long
Unicode as word
DebugStringLength as word
END OUTPUT_DEBUG_STRING_INFO

TYPE RIP_INFO  'RipInfo
data as long
END RIP_INFO

declare function ContinueDebugEvent lib "kernel32" _
  (PID as long, ThreadID as long, status as long) as long
declare function DebugActiveProcess lib "kernel32" _
  (PID as long) as long
'declare sub DebugBreak lib "kernel32"  'in debugged app
declare function GetThreadContext lib "kernel32" _
  (hT as long, lpContext as long) as long
declare function ReadProcessMemory lib "kernel32" _
  (hP as long, lpAddr as long, lpBuf as long, _
   nbytes as long, lpBytesRead as long) as long
declare function ResumeThread lib "kernel32" _
  (hT as long) as long  'previous suspend count
declare function SetThreadContext lib "kernel32" _
  (hT as long, lpContext as long) as long
declare function SuspendThread lib "kernel32" _
  (hT as long) as long  'previous suspend count
declare function WaitForDebugEvent lib "kernel32" _
  (lpDE as long, msec as long) as long
declare function WriteProcessMemory lib "kernel32" _
  (hP as long, lpAddr as long, lpBuf as long, _
   nbytes as long, lpBytesRead as long) as long
