'icmp.inc Copyright 2002-2006 James J Keene
'Updated: Mar 31, 2007

$DEFINE IP_STATUS_BASE 11000
$DEFINE IP_SUCCESS 0
$DEFINE IP_BUF_TOO_SMALL 11001
$DEFINE IP_DEST_NET_UNREACHABLE 11002
$DEFINE IP_DEST_HOST_UNREACHABLE 11003
$DEFINE IP_DEST_PROT_UNREACHABLE 11004
$DEFINE IP_DEST_PORT_UNREACHABLE 11005
$DEFINE IP_NO_RESOURCES 11006
$DEFINE IP_BAD_OPTION 11007
$DEFINE IP_HW_ERROR 11008
$DEFINE IP_PACKET_TOO_BIG 11009
$DEFINE IP_REQ_TIMED_OUT 11010
$DEFINE IP_BAD_REQ 11011
$DEFINE IP_BAD_ROUTE 11012
$DEFINE IP_TTL_EXPIRED_TRANSIT 11013
$DEFINE IP_TTL_EXPIRED_REASSEM 11014
$DEFINE IP_PARAM_PROBLEM 11015
$DEFINE IP_SOURCE_QUENCH 11016
$DEFINE IP_OPTION_TOO_BIG 11017
$DEFINE IP_BAD_DESTINATION 11018
$DEFINE IP_ADDR_DELETED 11019
$DEFINE IP_SPEC_MTU_CHANGE 11020
$DEFINE IP_MTU_CHANGE 11021
$DEFINE IP_UNLOAD 11022
$DEFINE IP_ADDR_ADDED 11023
$DEFINE IP_GENERAL_FAILURE 11050
$DEFINE MAX_IP_STATUS 11050
$DEFINE IP_PENDING 11255

Declare FUNCTION inet_addr Lib "wsock32.dll" _
  (ByVal cp As String) As LONG
Declare FUNCTION IcmpCreateFile Lib "icmp.dll" () As Long
Declare FUNCTION IcmpCloseHandle Lib "icmp.dll" _
  (IcmpHandle As Long) As Long
Declare FUNCTION IcmpSendEcho Lib "icmp.dll" _
  (IcmpHandle As Long, DestinationAddress As LONG,_
  RequestData As String, RequestSize As Integer,_
  ptrRequestOptions As Long, ptrReplyBuffer As LONG,_
  ReplySize As Long, Timeout As Long) As Long

'Two structures -- ReqOpts and Reply -- are used in API calls
'and are incorporated as member sections of the OBJECT:

OBJECT ICMP
  'ReqOpts are TTL, TOS, Flags, OptionsSize as bytes; ptrOptions as Long
  TTL As BYTE = 255
  TOS As BYTE
  Flags As BYTE
  OptionsSize As BYTE
  ptrOptions As LONG
  'Reply size = 284
  Address As LONG  'Address that replied
  Status As LONG    '0 if echo OK
  RoundTripTime As LONG  'in ms
  DataSize As INTEGER    'DataSize and Reserved
  ptrData As LONG
  Options As LONG
  ptrOptionsData As LONG
  Data As STRING *256
  'end Reply
  TimeOut As LONG = 3500
  Handle As LONG
  EchoString As STRING*256 = "Echo This"
  Close As FUNCTION
  Ping As FUNCTION
  ReplyAddress As FUNCTION
  ReplyData As FUNCTION
  ReplyStatus As FUNCTION
  ReplyTTL As FUNCTION
END ICMP

Declare FUNCTION ICMPClose As LONG
Declare FUNCTION Ping(RemoteIP As STRING) AS LONG
Declare FUNCTION ReplyAddress As STRING
Declare FUNCTION ReplyData As STRING
Declare FUNCTION ReplyStatus As STRING
Declare FUNCTION ReplyTTL AS LONG

FUNCTION ICMPClose As LONG
DEFINT h
h=BYREF(@ICMP.Handle)
IF h <= zero THEN
  Result = -1
ELSE
  Result = IcmpCloseHandle(h)
END IF
END FUNCTION

FUNCTION Ping(RemoteIP As STRING) AS LONG
DIM Addr As LONG, h As LONG, r As LONG, Echo$ As STRING
Result = -1
h=BYREF(@ICMP.Handle)
IF NOT h THEN h = IcmpCreateFile
IF NOT h THEN Exit Function ELSE BYREF(@ICMP.Handle)=h 
Addr = inet_addr(RemoteIP)
IF Addr = &HFFFFFFFF THEN Exit Function
MEMSET @ICMP.Address,zero,284  'clear Reply
Echo$ = VARPTR$(@ICMP.EchoString)
r = IcmpSendEcho(h, Addr, Echo$, Echo$.Length), _
  @ICMP.TTL, @ICMP.Address, 284, BYREF(@ICMP.TimeOut))
IF r = 1 THEN Result = BYREF(@ICMP.RoundTripTime)
END FUNCTION

FUNCTION ReplyAddress as STRING
Dim IP As LONG, Sock As SOCKET
Result = NULL
IP = BYREF(@ICMP.Address)
IF NOT IP THEN Exit Function
Result = Sock.AddrToStr(IP)
END FUNCTION

FUNCTION ReplyStatus As STRING
Dim msg As STRING
Select Case BYREF(@ICMP.Status)
  Case IP_SUCCESS:               msg = "ip success"
  Case IP_BUF_TOO_SMALL:         msg = "ip buf too_small"
  Case IP_DEST_NET_UNREACHABLE:  msg = "ip dest net unreachable"
  Case IP_DEST_HOST_UNREACHABLE: msg = "ip dest host unreachable"
  Case IP_DEST_PROT_UNREACHABLE: msg = "ip dest prot unreachable"
  Case IP_DEST_PORT_UNREACHABLE: msg = "ip dest port unreachable"
  Case IP_NO_RESOURCES:          msg = "ip no resources"
  Case IP_BAD_OPTION:            msg = "ip bad option"
  Case IP_HW_ERROR:              msg = "ip hw_error"
  Case IP_PACKET_TOO_BIG:        msg = "ip packet too_big"
  Case IP_REQ_TIMED_OUT:         msg = "ip req timed out"
  Case IP_BAD_REQ:               msg = "ip bad req"
  Case IP_BAD_ROUTE:             msg = "ip bad route"
  Case IP_TTL_EXPIRED_TRANSIT:   msg = "ip ttl expired transit"
  Case IP_TTL_EXPIRED_REASSEM:   msg = "ip ttl expired reassem"
  Case IP_PARAM_PROBLEM:         msg = "ip param_problem"
  Case IP_SOURCE_QUENCH:         msg = "ip source quench"
  Case IP_OPTION_TOO_BIG:        msg = "ip option too_big"
  Case IP_BAD_DESTINATION:       msg = "ip bad destination"
  Case IP_ADDR_DELETED:          msg = "ip addr deleted"
  Case IP_SPEC_MTU_CHANGE:       msg = "ip spec mtu change"
  Case IP_MTU_CHANGE:            msg = "ip mtu_change"
  Case IP_UNLOAD:                msg = "ip unload"
  Case IP_ADDR_ADDED:            msg = "ip addr added"
  Case IP_GENERAL_FAILURE:       msg = "ip general failure"
  Case IP_PENDING:               msg = "ip pending"
  Case Else:                     msg = "unknown msg returned"
END Select
Result = msg
END FUNCTION

FUNCTION ReplyData As STRING
defLNG r
Result=null: r=zero
IF BYREF(@ICMP.Address) THEN r=BYREF(@ICMP.ptrData)
IF r THEN Result = VARPTR$(r)
END FUNCTION

FUNCTION ReplyTTL AS LONG
Result = BYREF(@ICMP.Options) AND &HFF  'get lower byte
END FUNCTION

$UNDEF IP_STATUS_BASE, IP_SUCCESS, IP_BUF_TOO_SMALL
$UNDEF IP_DEST_NET_UNREACHABLE, IP_DEST_HOST_UNREACHABLE
$UNDEF IP_DEST_PROT_UNREACHABLE, IP_DEST_PORT_UNREACHABLE
$UNDEF IP_NO_RESOURCES, IP_BAD_OPTION, IP_HW_ERROR
$UNDEF IP_PACKET_TOO_BIG, IP_REQ_TIMED_OUT, IP_BAD_REQ
$UNDEF IP_BAD_ROUTE, IP_TTL_EXPIRED_TRANSIT, IP_TTL_EXPIRED_REASSEM
$UNDEF IP_PARAM_PROBLEM, IP_SOURCE_QUENCH, IP_OPTION_TOO_BIG
$UNDEF IP_BAD_DESTINATION, IP_ADDR_DELETED, IP_SPEC_MTU_CHANGE
$UNDEF IP_MTU_CHANGE, IP_UNLOAD, IP_ADDR_ADDED
$UNDEF IP_GENERAL_FAILURE, MAX_IP_STATUS, IP_PENDING
