'load_mem.inc Copyright 2007 James J Keene
'Updated Oct 29, 2007

'Usage: hMem = LoadFromMem (pEXE, pEntry)
'where hMem is virtual ram handle used,
'pEXE is a pointer to the .exe or .dll in ram,
'and pEntry is address to return .exe entry.

DECLARE FUNCTION LoadFromMem _
  (pEXE as LONG, pEntry AS LONG) AS LONG
DECLARE FUNCTION VirtualAlloc LIB "kernel32" _
  (a1 as long, a2 as long, a3 as long, a4 as long) _
   as long

$define VirtSize 8
$define RVA 12
$define PhysSize 16
$define PhysOffset 20

FUNCTION LoadFromMem
defint i,j,p0,p1,p2
defint hRam,impsec,reloc,delta,hLib
defword w,nsect
result=zero
w=byref(pEXE)
if w<>&H5A4D THEN exit function  'not "MZ"

i=byref(pEXE+&H3C)
p0=IADD(pEXE,i)   'point to "PE" header

if byref(p0)<>&H4550 then exit function  'not "PE 00 00"
impsec=byref(p0+&H80) 'imports
reloc=byref(p0+&HA0)  'relocation data
nsect=byref(p0+6)     'n sections
i=byref(p0+&H50)      'image size
IADD(i,4)  'add padding
hRam=VirtualAlloc(zero,i,&H1000,&H40) 'MEM_COMMIT,PAGE_EXECUTE_READWRITE
if not hRam then exit function
delta=byref(p0+&H34): ISUB(delta,hRam)  'for relocations
i=byref(p0+&H28)  'get entry 
byref(pEntry)=IADD(hRam,i)  'return entry to app
memcpy hRam,pEXE,byref(p0+&H54)  'size of "pre-section" headers

IADD(p0,&HF8)  'point to section headers
p2=pEXE: j=byref(p0+PhysOffset): IADD(p2,j)  'source address
for i=1 to nsect
p1=hRam: j=byref(p0+RVA): IADD(p1,j)  'p=section address
j=byref(p0+PhysSize)
memcpy p1,p2,j 'copy p2 to p1
IADD(p2,j)     'point to next source data address
IADD(p0,&H28)  'point to next section
next i

p0=iadd(hRam,impsec)  'point to import descriptors
isub(p0,&H14)  'size of import descriptor

restart:
iadd(p0,&H14)
if byref(p0) then goto import1
if byref(p0+4) then goto import1
if byref(p0+8) then goto import1
if byref(p0+12) then goto import1
if not byref(p0+16) then goto relocate

import1:
p1=byref(p0+12): iadd(p1,hRam)
funccall LoadLibraryA,p1 
hLib=retfunc  'lib handle
i=byref(p0): iadd(i,hRam)
j=byref(p0+16): iadd(j,hRam)
import2:
p2=byref(i)  'function name
if not p2 then goto restart
iadd(p2,hRam): iadd(p2,2)
funccall GetProcAddress,hLib,p2
p2=retfunc: byref(j)=p2
iadd(i,4): iadd(j,4)
goto import2

relocate:
IF reloc then
p0=iadd(hRam,reloc)
reloc_block:
p1=byref(p0)
if not p1 then goto end_load
p2=byref(p0+4) 'reloc data size
ISUB(p2,8): IADD(p0,8)  'skip header
do_reloc:
j=byref(p0)
ISHR(i,12)
if not i then goto zero_eax
j=j and &HFFF: IADD(j,p1): IADD(j,hRam)
i=byref(j): isub(i,delta)
byref(j)=i
zero_eax:
IADD(p0,2)
iSUB(p2,2)
IF p2 then goto do_reloc else goto reloc_block
end if
end_load:
result=hRam
END FUNCTION

$undef VirtSize,RVA,PhysSize,PhysOffset
