'profile.inc Copyright 2006 James J Keene
'Updated: Dec 8, 2006

'profile.bas shows usage. 
'Any number of PROFILE Objects may be used.

'global variables and pointers for FILETIME values
dim P_t0 as INT64: defint lpP_t0 = @P_t0
dim P_t1 as INT64: defint lpP_t1 = @P_t1

OBJECT PROFILE
 Ticks as LONG   'number of 100 nano-second intervals
 TicksUpper as LONG
 Trials as LONG
 WriteFile as LONG  'savetofile if not zero
 Name as STRING*32 = "Code_A"
 Init as SUB
 Start as SUB
 Stop as SUB
 Report as SUB
END PROFILE

declare function GetCurrentThread lib "kernel32" as long
declare sub GetThreadTimes lib "kernel32"_
  (hT as long, lpCT as long, lpET as long,_
   lpKT as long, lpUT as long) as long

declare sub PROFILEInit
declare sub PROFILEStart
declare sub PROFILEStop
declare sub PROFILEReport

sub PROFILEInit
self.Init=GetCurrentThread  'store hThread here
self.Ticks = zero: self.TicksUpper = zero
self.Trials = zero
end sub

sub PROFILEStart
self.Trials=self.Trials+one
GetThreadTimes(self.Init,lpP_t0,lpP_t0,lpP_t0,@PROFILE.Start)
end sub

sub PROFILEStop
GetThreadTimes(self.Init,lpP_t0,lpP_t0,lpP_t0,lpP_t1)
memcpy lpP_t0,@PROFILE.Start,8   'get begin user time
dec(P_t1, P_t0)  'P_t1=P_t1-P_t0  'get difference
memcpy lpP_t0,hbObj,8  'get 64-bit self.Ticks
inc(P_t0, P_t1)  'P_t0=P_t0+P_t1  'add to total
memcpy hbObj,lpP_t0,8  'save 64-bit self.Ticks
end sub

sub PROFILEReport
memcpy lpP_t0,hbObj,8  'get 64-bit self.Ticks
defreal10 t = P_t0 / 10000000    'count to seconds
defstr r$
r$.additems str$(self.Trials), self.Name, str$(t), "seconds;"
t = 0.10 * P_t0 / self.Trials
r$.additems str$(t), "usec/trial"
r$=replacesubstr$(r$,crlf,space)
if self.WriteFile then
  r$.writestr(crlf,2)
  r$.savetofile self.Name+hex$(self.Start)+".dat"
else
  if isconsole then print r$ else showmessage r$
end if
self.Ticks = zero: self.TicksUpper = zero
self.Trials = zero
end sub
