'threads.inc Copyright 2007 James J Keene
'Updated: Sep 20, 2006

DIM hbLock as MEMORY

'The ObjPtr arguments below
'1) are objptr() results, e.g., i=objptr(x)
'where x is any dimensioned variable or object.
'2) are never used directly in multithreading.
'That is, where i above is a thread local variable,
'Usage:
'push i: LockObj: pop i: r=retfunc
'push i: UnlockObj: pop i
'push i: WaitObj: pop i

declare sub LockObj
declare sub UnlockObj
declare sub WaitObj

'Add objptr() arg to hbLock MEMORY array
'Returns 0 successs; -1 failure
sub LockObj
defint i,j,k
begin thread
'is obj locked now?
k=Stack(1)
hbLock.position = zero
while hbLock.position < hbLock.len
hbLock.read(i)
if i=k then retval -1: exit thread 
iadd(j,4)
end while
'put obj in locked list
hbLock.position = zero: j=zero
while hbLock.position < hbLock.len
hbLock.read(i)
if not i then
  hbLock.position=j: hbLock.write(k): exit while 
end if
iadd(j,4)
end while
if j>=hbLock.len then hbLock.write(k) 'add item
retval zero
end thread
end sub

'Remove objptr() arg from hbLock MEMORY array.
'Should be invoked *only* by thread that did lock.
'No check if locking thread = unlocking thread.
sub UnlockObj
defint i,j,k
begin thread
k=Stack(1)
hbLock.position = zero: j=zero
while hbLock.position < hbLock.len
hbLock.read(i)
if i=k then  'write 0 to unlock
  hbLock.position=j: i=zero: hbLock.write(i): exit while 
end if
iadd(j,4)
end while
end thread
end sub

'Blocking wait if obj is locked
sub WaitObj
defint i,k
begin thread
k=Stack(1)
is_locked:
hbLock.position = zero
while hbLock.position < hbLock.len
hbLock.read(i)
if i=k then sleep 0.01: goto is_locked
end while
end thread
end sub
