'Unicode.inc Copyright 2005 James J Keene
'Updated: Feb 23, 2005

'ASCIIZ converts a UNICODE string to ASCIIZ
'UNICODE converts an ASCIIZ string to UNICODE

'These are the real Unicode strings, not just 16-bit
'character strings which have also been called "unicode".

'Real Unicode strings are actually data packets which 
'may contain language and RichText information, whether
'or not the characters are 8-bit or 16-bit encoded.

DECLARE FUNCTION ASCIIZ(unistr as STRING) As STRING
DECLARE FUNCTION UNICODE(ascstr as STRING) As STRING

FUNCTION ASCIIZ(unistr as STRING) As STRING
DEFSTR s$
DEFINT i
DEFWORD sLength, sCode, xTmp
DEFBYTE xB1, xB2, j
s$="": unistr.Position = zero
sLength=unistr.ReadNum(2): xTmp=zero
sCode=unistr.ReadNum(1)
IF sCode AND 1 THEN sLength=2*sLength 'String not compressed
'Remove comment in next three lines for RichText and FarEast
'IF sCode AND 8 THEN xTmp=unistr.ReadNum(2)*4   'RichString
'IF sCode AND 4 THEN i=unistr.ReadNum(4): INC(xTmp,i) 'FarEast
'IF xTmp THEN unistr.Position=unistr.Position+xTmp

FOR i=1 to sLength step 1
  xB1=unistr.ReadNum(1)
  'for 16-bit char and NOT (FarEast OR RichText), get odd bytes only 
  IF sCode=1 THEN
    '16-bit char, NOT (FarEast OR RichText), get odd bytes only 
    xB2=unistr.ReadNum(1): INC(i)
    SELECT CASE xB2
    CASE 4 'RUSSIAN
    IF xB1=1 THEN j=167 ELSE j=176
    IF xB1=81 THEN j=103
    xB1=xB1+j
    'insert other languages here
    END SELECT
  END IF
  'insert sCode = 4 and = 8 here
  s$.write(xB1)  's$=s$+CHR$(xB1)
NEXT i
RESULT=s$
END FUNCTION

'produces compressed unicode string
FUNCTION UNICODE(ascstr as STRING) As STRING
DEFSTR r$
DEFWORD wLength
DEFBYTE xB0
r$="": wLength=ascstr.length
IF wLength THEN
  r$.write(wLength): r$.write(xB0): r$.write(ascstr)
END IF
RESULT=r$
END FUNCTION
