'Commander Keene Copyright 2006 James J Keene
'Updated: Oct 11, 2007

'If you modify this program and wish to post/distribute
'such modification, please remove all reference to
'"Commander Keene" to avoid confusion among other users.

'This code is provided as a tutorial in HotBasic coding.
'Please email author re improvements you might make
'for inclusion in this "official" version.

'Usage:
'comkeene
'starts program with 80x25 screen
'comkeene 43
'starts program with 80x43 screen (Windows only)

$APPTYPE CONSOLE: $TYPECHECK ON

'uncomment the following line to compile for Linux:
'$DEFINE LINUX

$include "justify.inc"
$include "sortlist.inc"
$include "dirtree.inc"

declare sub GetDir (p$ as string)
declare sub ShowMain
declare sub ShowMsg
declare sub ShowCmd
declare sub ShowLeft
declare sub ShowRight

$include "hlistbox.inc"

defstr title$="Commander Keene"
$IFDEF LINUX
defstr slash = "/"
$ELSE
defstr slash = "\"
app.title=title$
app.icon = "HotBasic.ico"
$ENDIF

defstr c$,cmd$,d$,d1$,f$,r$,t$
defint i,j,k,n,key
defint iline,pline,fline
dim lp as hLISTBOX, rp as hLISTBOX
dim vp as hLISTBOX, dp as hLISTBOX
dim mp as hLISTBOX, help as hLISTBOX
this=lp

vp.Width=79: vp.Height=23
vp.TitleBkgColor=5

help.Left=2: help.Top=7:
help.Width=36: help.Height=8
help.Title="Commander Keene Help"
help.TitleBkgColor=6: help.BkgColor=5
help.Center=true
help.additems null,"Episode IX:",_
 "Commander Keene explores cyberspace",_
 null,"Copyright 2006 James J Keene",_
 null,"doctorelectron@cwdom.dm"
help.Lines=7
dp=help  'copy custom object!
dp.Color=14: dp.BkgColor=9

mp.Left=5: mp.Top=5:
mp.Width=70: mp.Height=15
mp.Title="Menu: enter runs item; delete/F8 removes item"
mp.TitleBkgColor=6: mp.Color=0: mp.BkgColor=5
mp.Center=true

$IFDEF LINUX
defstr inifile$=curdir$+slash+"comkeene.ini"
$ELSE
defstr inifile$=app.path+"comkeene.ini"
$ENDIF
defstr ini$,editor$
if fileexists(inifile$) then
  ini$.loadfromfile inifile$
  lp.Title=ini$.Item(zero)
  rp.Title=ini$.Item(one)
  editor$=ini$.Item(2)
  j=ini$.itemcount: dec(j)
  if j>=3 then
    mp.Cursor=one
    for i=3 to j: mp.additems ini$.item(i): inc(mp.Lines)
    next i
    ini$.clear
  end if
else
$IFDEF LINUX
  t$=slash
$ELSE
  t$="c:\"
$ENDIF
  lp.Title=t$
  rp.Title=t$
end if

lp.Top=2: lp.Height=20
gosub Refresh_Left
lp.Focus=true

rp.Left=41: rp.Top=2: rp.Height=20
gosub Refresh_Right

fline=25: pline=24: iline=23

$IFNDEF LINUX
IF command$(1)="43" then
  Declare sub SetConsoleWindowInfo LIB "kernel32" _
  (hCO as LONG, fAbs As LONG, lpRect As LONG)

  TYPE SMALL_RECT
  left as short
  top as short
  right as short = 79
  bottom as short = 42
  END SMALL_RECT

  dim sr as SMALL_RECT

  SetConsoleWindowInfo(console.outputhandle,1,@sr)
  lp.Height=38: rp.Height=38
  mp.Height=33: vp.Height=41
  fline=43: pline=42: iline=41
  this=lp
end if
$ENDIF

ShowMain

GetKeyCmd:
i=Console.Event
IF i=one AND Console.KeyDown THEN

key=console.KeyCode
SELECT CASE key

CASE 27,3,&H79
IF vp.Focus THEN
  vp.Focus=false: vp.clear
  ShowMain: goto Key_Done
end if
IF dp.Focus THEN dp.Focus=false: ShowLeft: goto Key_Done
if mp.Focus then mp.Focus=false: ShowMain: goto Key_Done
if key=27 then goto Key_Done

ini$.additems lp.Title,rp.Title,editor$
ini$.addlist mpEx
ini$.savetofile inifile$

$IFDEF LINUX
setconsolemode 7
$ENDIF

cls: App.Terminate   'exit with ctrl-C or F10

case 8  'BACK
if cmd$.length then cmd$=left$(cmd$,cmd$.length-one): ShowCmd
goto Key_Done

CASE 13  'enter
if vp.Focus then goto Key_Done
if dp.Focus then
  p$=dp.item(dp.TopItem+dp.Cursor-one)
  dp.Focus=false: dp.clear
  if not lp.Focus then ShowLeft
  goto Refresh
end if
if mp.Focus then
  p$=mp.item(mp.TopItem+mp.Cursor-one)
  mp.Focus=false: color 7,zero
  if p$.length then
    goto Do_Cmd2
  else
    ShowMain: goto Key_Done
  end if
end if

gosub Get_Path: gosub Fix_Path
if cmd$.length then goto Do_Cmd
j=zero
gosub Get_File  'get f$
if j then
'directory -- display it
  if f$=".." then
    i=p$.length: dec(i)
    Next_Strip:
    if p$[i]<>slash then dec(i): goto Next_Strip
    p$=left$(p$,i): gosub Restore_Cursor
  else
    p$.write(f$): gosub Fix_Path: gosub Save_Cursor
  end if
  Refresh:
  IF lp.Focus THEN
$IFNDEF LINUX
    lp.Title=lcase$(p$)
$ELSE
    lp.Title=p$
$ENDIF
    gosub Refresh_Left
    if left$(lpEx,2)=".." then lp.Cursor=one: lp.TopItem=zero
    ShowLeft
  else
$IFNDEF LINUX
    rp.Title=lcase$(p$)
$ELSE
    rp.Title=p$
$ENDIF
    gosub Refresh_Right
    if left$(rpEx,2)=".." then rp.Cursor=one: rp.TopItem=zero
    ShowRight
  end if
'  ShowCmd: gosub Show25
else
'file -- run it
  cmd$=f$
$IFDEF LINUX
$ENDIF
  Do_Cmd:  'cmd$.lenght>0 & enter
$IFNDEF LINUX
  if instr(cmd$,":") then 
$ELSE
  if cmd$[1]=slash then
$ENDIF
    p$=cmd$
  else
    p$.write(cmd$)
  end if
  cmd$.clear
$IFDEF LINUX
  if right$(p$,3)=".gz" then p$="/usr/bin/man "+p$
$ENDIF
  if mpEx.indexof(p$)<zero then
    mp.additems p$: inc(mp.Lines): inc(mp.Cursor)
  end if

  Do_Cmd2:  'F2 Menu selection = p$
  gosub Set_PathName_Dir
  setconsolemode 7  'restore console
  cls: print p$: shell p$
  i=retfunc  'get exit code
  setconsolemode 7  'restore console
  color 7,0
  print "Exit Code = "; i; tab;: pause
  setconsolemode 0  'back to .event mode
  ShowMain
end if
goto Key_Done

CASE 38,104  'up
gosub Get_This
if i>one then
  dec(i): goto LB_repaint
else
  if i=one and j>zero then
    dec(j)
    LB_repaint:
    this.Cursor=i: this.TopItem=j
    if vp.Focus then
      vp.Show
      i=this.TopItem+this.Cursor: i=100*i/this.Lines
      t$=str$(i)+"% ":
      locate 1,74: color zero,7
      print JustRight(t$,6);
      ShowCmd: goto Key_Done
    elseif dp.Focus then
      dp.Show: ShowCmd: goto Key_Done
    elseif mp.Focus then
      mp.Show: ShowCmd: goto Key_Done
    elseif lp.Focus then
      ShowLeft
    else
      ShowRight
    end if
  end if
end if
goto Key_Done

CASE 40,98  'down
gosub Get_This
if i<this.Lines then
  if i<this.Height then
    inc(i): goto LB_repaint
  else
    if j < this.Lines-i then inc(j): goto LB_repaint
  end if
end if
goto Key_Done

CASE 37,100  'left
if vp.Focus then goto Key_Done
if not lp.Focus then goto Focus_Left

CASE 39,102  'right
if vp.Focus then goto Key_Done
if not rp.Focus then goto Focus_Right

CASE &H21  'pageup
gosub Get_This
n=j+i-this.Height
if n<zero then n=zero
j=n: i=1
Goto LB_repaint

CASE &H22  'pagedown
gosub Get_This
n=j+i
k=n+this.Height
if k>this.Lines then k=this.Lines
j=k-this.Height: dec(j)
if j<zero then j=zero
i=k-j
if i>this.Height then dec(i)
if i>this.Lines then i=this.Lines
goto LB_repaint

CASE &H23  'end
gosub Get_This
LB_End:
i=this.Height: k=this.Lines-i
LB_Scroll:
if k>=zero then j=k else j=zero
Goto LB_repaint 

CASE &H24  'home
gosub Get_This
i=one: j=zero: Goto LB_repaint

END SELECT

'F8 or Delete
if mp.Focus and (key=&H2E or key=&H77) then
  gosub Get_This: mp.delitems i+j-one
  dec(mp.Lines): goto LB_repaint 
end if

if vp.Focus OR dp.Focus OR mp.Focus then goto Key_Done

SELECT CASE key

CASE 9  'tab
IF lp.Focus THEN
  Focus_Right:
  lp.Focus=false: rp.Focus=true
ELSE
  Focus_Left:
  lp.Focus=true: rp.Focus=false 
END IF
New_Focus:
ShowLeft: ShowRight: ShowCmd

CASE &H70  'F1  Help
help.Show: c$=get$(one)
ShowLeft ': ShowCmd

CASE &H71  'F2  Menu
mp.Focus=true: mp.Show

CASE &H72  'F3  View
cls: color 7,zero: print "Loading file..."
gosub Path_Name
d$.loadfromfile p$
vp.Title="View: "+p$+space+str$(d$.length)+" bytes"
vp.clear: vp.Lines=zero: vp.View=one
if not instr(d$,chr$(zero)) then
  if instr(d$,tab) then d$=replacesubstr$(d$,tab,"  ")
  if not instr(d$,crlf) then d$=replacesubstr$(d$,chr$(10),crlf)
  vp.AddList d$
  vp.Lines=d$.itemcount
  vp.Indent=zero
else
  vp.Indent=one
  t$=hex$(zero): t$.writestr(": ",2)
  for i=one to d$.length
  c$=d$[i]: k=asc(c$): r$=right$(hex$(k),2)+space
  t$.write(r$)
$IFNDEF LINUX
  if k<=&H1A then c$=space
$ELSE
  if k>&H7E OR k<=&H1F then c$=space
$ENDIF
  f$.write(c$)
  if (i mod 16) = zero then
    t$.write(f$): f$.clear
    vp.AddItems t$: inc(vp.Lines)
    t$=hex$(i): t$.writestr(": ",2)
  end if
  next i
  if i mod 16 then vp.AddItems t$: inc(vp.Lines)
  locate fline,one
  print " Commander Keene descends into deep cyberspace";
end if 
vp.Cursor=one: vp.TopItem=zero
vp.Focus=true: d$.clear
vp.Show

CASE &H73  'F4  Edit
if not editor$.Length then
  gosub Clear24: color 14,zero
  print "Enter preferred text editor pathname: ";: gosub Line_Input
  editor$=trim$(c$): ShowCmd
  if not editor$.length then exit select
end if
gosub Path_Name
setconsolemode 7
shell editor$+space+p$
setconsolemode 0
ShowMain

CASE &H74  'F5  Copy
Move_Too:
gosub Path_Name
if lp.Focus then t$=rp.Title else t$=lp.Title
gosub Working
if j then
'directory
  gosub Fix_Path: c$=p$
  k=instr(c$,f$)
  d$=DirTree(c$,&H37)
  c$.additems null: c$.addlist d$: d$=SortList(c$)
  for i=zero to d$.itemcount-one
  c$=d$.item(i): r$=mid$(c$,k): p$=t$+r$
  if c$[c$.length]=slash then
    mkdir p$
  else
    if key=&H74 then copy c$,p$ else move c$,p$
  end if
  next i
  if key=&H75 then 'move: delete empty source directories
    for i=zero to d$.itemcount-one
    c$=d$.item(i)
    if c$[c$.length]=slash then rmdir c$
    next i
  end if
else
'file
  t$.write(f$)
  if key=&H74 then copy p$,t$ else move p$,t$
end if
if key=&H74 then
  if lp.Focus then gosub Refresh_Right: ShowRight _
    else gosub Refresh_Left: ShowLeft
else
  gosub Refresh_Right: ShowRight
  gosub Refresh_Left: ShowLeft
end if
ShowCmd

CASE &H75  'F6  MovRen
if lp.Title=rp.Title then 
'rename
  gosub Path_Name: t$=p$
  gosub Clear24: color 14,zero
  print "Enter new "; f$; " name: ";: gosub Line_Input
  if not c$.length then ShowCmd: exit select
  gosub Get_Path: gosub Fix_Path
  p$.write(c$): rename t$,p$
  gosub Get_Path: goto Refresh
else
'move
  goto Move_Too
end if

CASE &H76  'F7  MkDir
gosub Get_Path: gosub Fix_Path
gosub Clear24: color 14,zero
print "Enter new directory name: ";: gosub Line_Input
if not c$.length then ShowCmd: exit select
p$.write(c$): mkdir p$
gosub Get_Path: goto Refresh

CASE &H2E,&H77  'F8 or Delete
gosub Path_Name
gosub Clear24: color 14,zero
print "Delete "; p$;
if j then print " and all its files and sub-dirs";
print " (Y,N)? ";: c$=get$(one)
if ucase$(c$)<>"Y" then ShowCmd: exit select
gosub Working
if j then
'directory
  gosub Fix_Path: d$=DirTree(p$,&H37)
  p$.additems null: p$.addlist d$: d$=SortList(p$)
  for i=d$.itemcount-one to zero step -1
  p$=d$.item(i)
  if p$[p$.length]=slash then rmdir p$ else kill p$
  next i
else 
'file
$IFNDEF LINUX
  if not instr(p$,".") then p$.writestr(".",one)
$ENDIF
  kill p$
end if
gosub Save_Cursor
if lp.Focus then gosub Refresh_Left else gosub Refresh_Right
gosub Restore_Cursor
if lp.Focus then ShowLeft else ShowRight
ShowCmd

CASE &H78  'F9 Drive
$IFNDEF LINUX
declare sub GetLogicalDriveStringsA LIB "kernel32" _
  (d1 as long, d2 as long)
d$=string$(1024,space)
GetLogicalDriveStringsA 1024,@d$
i=retfunc: d$=left$(d$,i)
d$=replacesubstr$(d$,chr$(zero),crlf)
dp.clear: dp.AddList d$
dp.Lines=d$.itemcount: d$.clear
dp.Title="Select Drive"
dp.Focus=true: dp.Width=16: dp.Left=12: dp.Show
$ENDIF

CASE else
c$=chr$(console.char)
if c$>=space and c$<="~" then
  cmd$.write(c$): ShowCmd
end if

END SELECT
END IF

Key_Done:
Sleep 0.05: Goto GetKeyCmd

END

Clear24:
locate pline,one: color 7,zero: print space$(79);
locate pline,one
return

File_Info:
locate iline,k: color zero,7: print space$(40);
if fileexists(p$) or direxists(p$) then
  locate iline,k: print space; hex$(FILEREC.attr);
  locate iline,k+13: print JustRight(FILEREC.datelastwrite,10);
  locate iline,k+28: print JustRight(FILEREC.timelastwrite,11);
end if
ShowCmd
return

Fix_Path:
if p$[p$.Length]<>slash then p$.write(slash)
return

sub GetDir
d$.clear: d1$.clear
gosub Fix_Path
c$="Reading "+p$+"...": ShowMsg
$IFNDEF LINUX
r$ = Dir$(p$+"*.*",zero) 'get all
$ELSE
r$ = Dir$(p$,zero) 'get all
$ENDIF
Goto Do_File
Next_File:
r$ = Dir$  'gets next file if any
Do_File:
if not r$.Length then goto Sort_Dir
if r$="." then Goto Next_File  
$IFNDEF LINUX
if FILEREC.ATTR AND &H10 then
  r$=ucase$(r$): t$="<DIR>": goto Is_Dir
elseif FILEREC.ATTR AND &H4000 then
  exit if  'drive
$ELSE
if p$=slash and r$=".." then goto Next_File
if FILEREC.ATTR AND &H4000 then
'  r$=ucase$(r$)
  t$="<DIR>": goto Is_Dir
$ENDIF
else
$IFNDEF LINUX
  r$=lcase$(r$)
$ENDIF
  t$=str$(FILEREC.SIZE)
  Is_Dir:
  r$=left$(r$,37-t$.length)
  j=38 - r$.length - t$.length
  if j>zero then r$=r$+space$(j)
  r$.write(t$)
end if
IF t$="<DIR>" then d$.additems r$ else d1$.additems r$
Goto Next_File
Sort_Dir:
c$="Sorting "+p$+"...": ShowMsg
if not d$.length + d1$.length then
  d$.additems "..                               <DIR>"
else
  d$=SortList(d$)
  if d1$.length THEN d1$=SortList(d1$): d$.addlist d1$
end if
ShowCmd
end sub

Get_File:
IF lp.Focus THEN
  f$=lp.Item(lp.TopItem+lp.Cursor-one)
else
  f$=rp.Item(rp.TopItem+rp.Cursor-one)
end if
if instr(f$,"<DIR>") then j=one else j=zero
i=instr(f$,"  "): dec(i)
f$=left$(f$,i)
return

Get_Path:
if lp.Focus then p$=lp.Title else p$=rp.Title
return

Get_This:
IF vp.Focus THEN this=vp: goto This_Dat
IF dp.Focus THEN this=dp: goto This_Dat
IF mp.Focus THEN this=mp: goto This_Dat
IF lp.Focus THEN this=lp else this=rp
This_Dat:
i=this.Cursor: j=this.TopItem
return

Line_Input:
input c$
return

Path_Name:
gosub Get_File: gosub Get_Path: gosub Fix_Path
p$.write(f$)
return

Refresh_Left:
GetDir lp.Title
lp.clear: lp.AddList d$
lp.Lines=d$.itemcount: d$.clear
return

Refresh_Right:
GetDir rp.Title
rp.clear: rp.AddList d$
rp.Lines=d$.itemcount: d$.clear
return

Restore_Cursor:
if lp.Focus then
  lp.Cursor=lp.CursorLast
  lp.TopItem=lp.TopLast
else
  rp.Cursor=rp.CursorLast
  rp.TopItem=rp.TopLast
end if
return

Save_Cursor:
if lp.Focus then
  lp.CursorLast=lp.Cursor
  lp.TopLast=lp.TopItem
else
  rp.CursorLast=rp.Cursor
  rp.TopLast=rp.TopItem
end if
return

Set_PathName_Dir:
c$=reverse$(p$): i=instr(c$,slash)
if i then dec(i): c$=left$(p$,p$.length-i): chdir c$
return

Show25:
locate fline,2: color zero,3
print "Help    Menu    View    Edit    Copy    RenMov  MkDir   Delete  Drive   Quit  ";
locate fline,42
if lp.Title=rp.Title then print "Rename"; else print "Move  ";
color 7,zero
locate fline,one: print "1";
locate fline,8: print " 2";
locate fline,16: print " 3";
locate fline,24: print " 4";
locate fline,32: print " 5";
locate fline,40: print " 6";
locate fline,48: print " 7";
locate fline,56: print " 8";
locate fline,64: print " 9";
locate fline,72: print "10";
return

sub ShowCmd
gosub Clear24
gosub Get_Path: gosub Fix_Path
print p$; ">"; cmd$;
end sub

sub ShowLeft
lp.Show
if lp.Focus then
  gosub Path_Name
  k=lp.Left: gosub File_Info
end if
end sub

sub ShowMain
cls
color 15,5: print space;
print JustLeft(title$+" 1.5 Copyright 2006-2012 James J Keene",79);
gosub Show25: ShowLeft: ShowRight: ShowCmd
end sub

sub ShowMsg
gosub Clear24: print JustCenter(c$,78)
end sub

sub ShowRight
rp.Show
if rp.Focus then
  gosub Path_Name
  k=rp.Left: gosub File_Info
end if
end sub

Working:
gosub Clear24: print "Working...";
return
